/*********************************************************************
本ソースリストおよびソフトウェアは、ライセンスフリーです。
利用、編集、再配布等が自由に行えますが、著作権表示の改変は禁止します。

                               Copyright (c) 2010-2013 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/
/*
既知バグ
	[PC用/H8用/Arduino共通]
	・XBee Smart Plug/XBee Sensor等でネットワーク参加直後、
	　正しい値を応答しない場合がある。
	　一度、XBee Smart PlugのACコンセントを抜いて挿しなおせば治る。
		(Smart Plug側のファームウェア「XBP24-ZB_2264」の問題!?、仕様!?)
		
	[パソコン用]
	・特記事項なし
	
	[H8マイコン用]
	・特記事項なし
	
	[Arduino用]
	・標準SDライブラリ使用時にメモリ不足になる場合があります。
	　そのような場合は#define LITEを定義してLITEモードで動作させてください。
	・標準ライブラリの液晶を使用する場合は#define ADAFRUITを解除してください。
	　液晶の接続はハードウェアの説明の欄に従う、もしくは書き換えてください。
	・LEONARDOで使用する場合は、#define LEONARDOを定義してください。
		
制限事項
	・ソースはPC/H8/Arduino用で共通ですが拡張子が異なります。PC/H8は(xbee.c)を
	　Arduino用はxbee_arduinoフォルダ内のライブラリ(xbee.cpp)をインストールして
	　使用してください。
	・コマンド発行後の応答待ち中に他の受信パケットをキャッシュするかどうかを
	　#define CACHE_RES で設定しています。
	　※H8版ではデフォルトでCACHE_RESをOFFにしていますのでパケットを破棄します。
	　※xbee_forceでの指示を出してxbee_rx_callで待ち受ける使い方を推奨します。
	　※メモリーの大きなマイコンを使用した場合はキャッシュを有効にしてください。
	・受信パケットのAPIフレーム長は最大255バイト等に制限しています。(仕様は64KB)
	・複数のXBeeデバイスの切替はアプリでIEEEアドレスを指定して対応してください。
	・ショートアドレスは使っていません(IEEEアドレスで相手を特定します)
	・リモートXBeeをリセットするとリモート側がGPIO設定を忘れてしまいます。(仕様)
	　継続的に使用する場合はリモート側でATWR(設定情報の書き込みコマンド)を実行し
	　てください。但し、ATWRを頻繁に（自動で）行うことはおすすめしません。
	　(設定に誤りがあり不具合が発生してもリセットでは治らなくなる場合があります)
	・各種センサで温度測定を行う場合は内部発熱分を減算して補正する必要があります。
	　Digi純正のWall RouterやSmart Plugも同様に内部発熱の4℃を考慮して測定値から
	　減算必要があります。
	・キャッシュを利用時はxbee_fromは非キャッシュ機器のアドレスが代入されます。
	　受信した機器のアドレス取得にはxbee_result.FROM[8]を使用してください。
	　
	[Arduino用]
	・Ver 1.70よりも古いライブラリではXBeeからの応答を待ち受けるxbee_rx_callの
	　結果を変数のポインタ渡しで受けていました。
	　※Ver1.70以上はPC/H8用と同じxbee_result構造体のポインタ渡しになります。
	
	　移植方法＝ソースからテキスト置換で変更します。
	
	　①古いArduino用→新しいArduino用(Ver 1.70以降)への移植
	
			検索文字						置換文字
			ADCIN					->		xbee_result.ADCIN
			GPI						->		xbee_result.GPI.BYTE

	　②古いPC/H8用→新しいArduino用(Ver 1.70以降)への移植

			検索文字						置換文字
			xbee_result.ADC			->		xbee_result.ADCIN

	　③古いPC/H8用→新しいPC/H8用(Ver 1.70以降)への移植
		
			検索文字						置換文字
			xbee_result.ADC			->		xbee_result.ADCIN
			
アプリ向け提供関数

	byte xbee_myaddress( byte *address );
	void xbee_address( const byte *address );
	void xbee_from( byte *address );
	byte xbee_at(const char *in);
	byte xbee_rat(const byte *address, const char *in);
	byte xbee_atai(void);
	unsigned short xbee_atop(byte *pan_id);
	byte xbee_atnj( const byte timeout );
	byte xbee_ratnj( const byte *address, const byte timeout );
	byte xbee_ping( const byte *address );
	int xbee_batt(const byte *address );
	byte xbee_batt_force(const byte *address );
	(PC/H8)		byte xbee_gpio_config(const byte *address, const byte port, const enum xbee_port_type type );
	(arduino)	byte xbee_gpio_config(const byte *address, const byte port, const byte type );
	byte xbee_gpio_init( const byte *address );
	byte xbee_gpo( const byte *address, const byte port,const byte out );
	(EASY)		byte xbee_gpi(const byte *address, const byte port);
	(EASY)		unsigned int xbee_adc(const byte *address, const byte port){
	byte xbee_force( const byte *address );
	(PC/H8)		float xbee_sensor_result( XBEE_RESULT *xbee_result, const enum xbee_sensor_type type );
	(arduino)	float xbee_sensor_result( XBEE_RESULT *xbee_result, const byte type)
	byte xbee_rx_call( XBEE_RESULT *xbee_result );
	(EASY)		xbee_sensor(const byte *address, const enum xbee_sensor_type type );
	void xbee_init( const byte port );
	void lcd_disp( char *s );

	(arduino)
	xbee_rx_callの戻り値に必要な変数
	byte MODE;				// 受信モード(Frame Type)
	byte FROM[8];			// 送信元IEEEアドレス
	byte AT[2];				// ATコマンド
	byte STATUS;			// 応答結果(0:OK 1:ERROR)／AT結果／UART状態
	byte GPI[2];
	unsigned int ADCIN[4];	// ADCデータ
	byte DATA[CALL_SIZE];	// ペイロードデータ／ZCLヘッダ＋受信データ

バージョン

		*/
			#ifndef VERSION
				#define		VERSION	"1.72"
			#endif
		/*

主要な変更履歴
	2010/08/15	0.10	- 初回の公開版をリリース 基本動作部分の実験用
	2010/08/18	0.20	- ATNJ後にリセット追加、各関数の入出力型の見直し
	2011/08/14	0.30	- ライブラリ化のためにAPI関数の内容を全面見直し
	2012/03/31	0.60	- リモートADC値を応答する関数の追加
						- XBee Sensorに対応
	2012/04/07	0.80	- 総合試験の実施とバグ修正、仕様見直しなど
	2012/04/22	0.91	- H8マイコンの代わりにパソコン(cygwin)での動作に対応
	2012/07/15	1.00	- 基本機能(sample1～8)でのデバッグを完了。正式版リリース
	2012/08/25	1.15	-[重要]enum xbee_port_typeのADCをAINに変更
						- Arduino用へ移植
						- 起動時にシリアル速度が設定されない不具合を修正(PC用)
	2012/11/25	1.20	-[重要]電池電圧確認用コマンドを非同期型に変更
						  xbee_batt -> xbee_batt_force 応答はxbee_rx_call
	2012/12/09	1.30	- 液晶なしコンパイルオプション(#define LCD_H)の追加
						- ライトモード（#define LITE）の追加。ARDUINO版のみ検証
						- PC版で使用するシリアルポートをcom1～com10に拡張
						- 自分自身のアドレスのグローバル変数ADR_MYとSADR_MYを廃止
	2012/12/16	1.50	- Arduino版のライブラリ化(要Arduino IDEへのインストール)
						- コマンド応答待ち時に他のパケットをキャッシュ
						  (#define CACHE_RES 10でキャッシュ１０個が有効になる)
	2012/12/17	1.51	- リモートATの応答確認にAT値からMODE値に変更
						- H8コンパイルエラー対策(lcd_h8.cの２重呼び出し対策等)
	2012/12/18	1.52	- [重要] 関数lcd()をlcd_disp()に変更。
						- Arduino版ではライブラリ側のハード(LCD,LED,SW)をオフに
	2012/12/22	1.53	- [重要] atnjとratnjの戻り値を失敗時255に変更。
						- ATコマンドを送信する関数を追加。
	2012/12/23	1.54	- テスト用のprintfが残っていたことによるエンバグの修正
	2012/12/30	1.55	- LEONARDO対応、Arduino標準LCDの配線変更(DF ROBOT互換に)
	2013/01/12	1.56	- xbee_result.GPI[0]とGPI[1]の戻り値を入れ替え。
	2013/01/14	1.57	- xbee_gpio_configで自分アドレス取得失敗時のバグ修正
	2013/01/20	1.58	- xbeeの状態取得 xbee_ataiとxbee_atopコマンドの追加
	2013/04/03	1.60	- xbee_initによるXBeeリセット時の応答を読み取り廃棄
						- エラー出力を stderrに変更PC用(のみ)
						- xbee_result.GPI.PORT.Dnのエンバグ(Ver1.56～)修正
	2013/04/08	1.71	- [重要] Arduino用xbee_rx_callの引数を構造体に変更
						- [重要] xbee_rx_callの特定パケットの選択受信機能を削除
						- [重要] Arduino用xbee_sensor_resultの引数を構造体に変更
						- [重要] PC/H8用 xbee_result.ADCをADCINに変更
						- xbee_atに16進数のテキスト引数の処理のバグ修正
						- xbee_atnjでjoin後にatnj=0x05を設定(5秒間のJOIN有効)
						- PC/H8/Arduinoでライブラリを共通ソースに統合
	2013/00/00	1.72	- 作成中

参考文献

	Digi International Inc.
		XBee ZB RF Modules 90000976_D 8/18/2009
	BestTechnology CO.,LTD.
		H8/3664F I/O address definition Release 3.5 2005-11-08 (3694.h) 
	粕谷友章
		PC-UNIX関連ドキュメント「シリアルポートプログラミング」
	Massimo Banzi著 船田功訳
		Arduinoをはじめよう (オライリージャパン)
		
注意点
	唯一のシリアルポートをXBeeに接続しているのでデバッグにはLCDが必要です。(H8版)
	本ソフトの利用でいかなる損害が発生しても、一切、補償いたしません。
*/
/*********************************************************************
ライブラリ使用説明書

ハードウェア
	PC用	以下のハードが必要です。
			・USBを搭載したIBM PC/AT互換機(通常のWindows PC)
			・XBee-Fly USB または 純正XBIB-U-DEVなど
			　(http://www.geocities.jp/bokunimowakaru/diy/xbee/xbee-usb.html)
			・XBee Series 2 (ZB) モジュール
			
	H3694用	秋月電子通商で販売されている以下のハードウェアが必要です。
			・AKI-H8/3694F(QFP) タイニーマイコンキット
			・Ｈ８タイニーＩ／Ｏ（アイ・オー）ボード
			・小型スライドスイッチ 1回路2接点 SS12D01G4
			・LCDキャラクタディスプレイモジュール[20×4行] SC2004CS-B
			・XBeeモジュールをRS-232Cに接続する基板(純正XBIB-R-DEVなど)
			　(http://www.geocities.jp/bokunimowakaru/pict/xbee-cord_sch.gif)
			・RS-232Cケーブル
			・XBee Series 2 (ZB) モジュール
			
			　キャラクタ液晶はH8/3694のCN1の14～19ピンの各出力と電源、
			　GNDを液晶モジュールのDB4～7およびE、RSの各入力、および
			　電源に接続して製作します(下図参照)。 

					AKI-H8　　　　　　液晶モジュール
					(CN1)　　　　　　 (HD44780搭載)
					━━┓　　　　　　┏━━━━━┓　　　　┯ 5V
					　　┃P50　　　　 ┃　　　　　┃　　　　｜
					　14┠──────┨DB4　　Vdd┠───●┘
					　　┃P51　　　　 ┃　　　　　┃　　　｜
					　15┠──────┨DB5 　　　┃　　　＜
					　　┃P52　　　　 ┃　　　　　┃　┌→＞
					　16┠──────┨DB6　　VLC┠─┘　＜ 10k
					　　┃P53　　　　 ┃　　　　　┃　　　｜
					　17┠──────┨DB7　DB0-3┠─┐　｜
					　　┃P54　　　　 ┃　　　　　┃　｜　｜
					　18┠──────┨E　　　R/W┠─●　｜
					　　┃P55　　　　 ┃　　　　　┃　｜　｜
					　19┠──────┨RS　　 Vss┠─●─●┐
					　　┃　　　　　　┗━━━━━┛　　　┯┿┯
					　　
	Arduino用
			以下のハードが必要です。
			・Arduino
			・XBee Shield
			・XBee Series 2 (ZB) モジュール
			・LCDキャラクタディスプレイモジュール[20×4行] SC2004CS-B
			
			　キャラクタ液晶は以下のように接続する
			
			　                        rs rw en d0 d1 d2 d3
			　// LiquidCrystal xbee_ardlcd( 8, 7, 6, 5, 4, 3, 2)
			
	port:	port指定	IO名	ピン番号	共用		主な用途
			port= 0		DIO0	XBee_pin 20 (Cms)	    Commision コミッションボタン
			port= 1		DIO1	XBee_pin 19 (AD1)	    汎用入力用(DIN or AIN)
			port= 2		DIO2	XBee_pin 18 (AD2)	    汎用入力用(DIN or AIN)
			port= 3		DIO3	XBee_pin 17 (AD3)	    汎用入力用(DIN or AIN)
			port= 4		DIO4	XBee_pin 16 (RTS)	    汎用出力用
			port= 5		DIO5	XBee_pin 15 (Ass)	    ASSOSIATE indication
			port=10		DIO10	XBee_pin  6 (RSSI)	    RSSI indication (PWM)
			port=11		DIO11	XBee_pin  7			    汎用出力用
			port=12		DIO12	XBee_pin  4			    汎用出力用

ソフト開発環境

	共通	・X-CTU (Digi社)
			　PCもしくはH3694、Arduinoに接続する親機側のXBeeモジュールへ
			　Coordinatorのファームウェアを書き込むのに必要です。
			
				Device Type XBee Firmware    Ver. ハードウェア  
				-----------------------------------------------------
				Coordinator COORDINATOR API  2141 パソコンのシリアル端子
				                                  または秋月H8Tiny IO BOARD
				                                  またはArduino側に接続
				End Device  END DEVICE AT    2841 単体で駆動  

	PC用	・cygwin (http://www.cygwin.com/)
			・インストール時にdevl内のgcc coreとmakeを選択すること
			
	H3694用	・GCC Developer Lite(株式会社ベストテクノロジー)
			　http://www.besttechnology.co.jp/modules/knowledge/

			上記ホームページの「ナレッジベース」より、技術情報／ソフト
			ウェア／GCC Developer Liteからダウンロードできます。
			この開発環境に含まれるH3694用のターゲットファイルを使用し
			ていますので、他の環境で開発する場合は注意が必要です。

	Arduino用・Arduino IDE
*/

/*********************************************************************
インポート処理
*********************************************************************/
#ifndef LCD_TYPE_H
	#define LCD_TYPE_H
	#ifdef ARDUINO
	//	#define LEONARDO	// Arduino LEONARDを使用する場合に定義する
	//	#define LCD_H		// 液晶を本ライブラリで使用する場合に定義する
	//	#define ADAFRUIT	// 使用する液晶が Adafruit LCD Sheild の時に定義する
	#else // H8 or PC
		#define LCD_H
	#endif
//	#define LITE		// ライトモード(メモリ節約・機能制限)の時に定義する
	#define EASY_GPI	// xbee_gpi関数(リモートGPIO)を使用するときに定義する
	#define EASY_ADC	// xbee_adc関数(リモートADC)を使用するときに定義する
#endif

#ifndef XB_IMPORT_H
	#ifdef H3694
		#ifndef __3694_H__
			#include <3694.h>
		#endif
		#ifdef LCD_H
			#ifndef LCD_ROW_1
				#include "lcd_h8.c"
			#endif
		#endif
		/*
		void lcd_delay(unsigned int data);
		void lcd_toggle_E(void);
		void lcd_cls(void);
		void lcd_home(void);
		void lcd_control(unsigned char disonoff, unsigned char curonoff, unsigned char curblink);
		void lcd_goto(unsigned char mesto);
		void lcd_shift(unsigned char data);
		void lcd_putch(char data);
		void lcd_putstr(const char *data);
		void lcd_disp_bin(unsigned char x);
		void lcd_disp_hex(unsigned char i);
		void lcd_disp_1(unsigned int x);
		void lcd_disp_2(unsigned int x);
		void lcd_disp_3(unsigned int x);
		void lcd_disp_5(unsigned int x);
		void lcd_init(void);
		*/
	#elif ARDUINO
		//	#include <inttypes.h>
		#include "Arduino.h"
		//	#include "WProgram.h"	// #if ARDUINO < 100
		#ifdef LCD_H
			#ifndef ADAFRUIT
				// 通常のキャラクタLCDの場合
				#include <LiquidCrystal.h>
			#else
				// Adafruit I2C接続LCDの場合(Adafruit_RGBLCDShieldライブラリが必要)
				#include <Wire.h>
				#include <Adafruit_MCP23017.h>
				#include <Adafruit_RGBLCDShield.h>
			#endif
		#endif
		#ifndef LCD_ROW_1
			#define		LCD_ROW_1		0x00	//１行目先頭アドレス
			#define		LCD_ROW_2		0x40	//２行目先頭アドレス
			#define		LCD_ROW_3		0x14	//３行目先頭アドレス
			#define		LCD_ROW_4		0x54	//４行目先頭アドレス
		#endif
	#else // PC
		#include <stdio.h>
		#include <stdlib.h>
		#include <string.h>
		#include <termios.h>
		#include <sys/signal.h>
		#include <sys/time.h>
		#include <unistd.h>
		#include <fcntl.h>
		#define BAUDRATE B9600
		#ifndef LCD_ROW_1
			#include "lcd_pc.c"
		#endif
		#include <time.h>			// クロックタイマー用
	#endif
#endif

/*********************************************************************
定数の設定
*********************************************************************/
#ifndef XB_DEFINE_H
	#define XB_DEFINE_H
	#ifndef NAME
		#define		NAME	"ZB Coord"
	#endif

	#ifdef H3694
		#define	ERRLOG
		#define	LED1_OUT	IO.PDR8.BIT.B0	// LED赤の接続ポート(エラー用)
		#define	LED2_OUT	IO.PDR8.BIT.B1	// LED緑の接続ポート(動作確認用)
		#define	LCD_EN		IO.PDR8.BIT.B6	// 液晶用電源
		#define	BUTN		IO.PDR8.BIT.B2	// ボタンの接続ポート
		#define	SCI_SIZE	256				// シリアルデータ長(大きすぎるとRAMが不足する)
		#define	API_SIZE	128				// 受信用APIデータ長(32～255)
		#define	API_TXSIZE	64				// 送信用APIデータ長(32～255)兼シリアル送信最大長
		#define	CALL_SIZE	32				// コールバック関数xbee_rx_call用戻りデータ(9～256)
		#define	XB_AT_SIZE	32				// ATコマンドの最大長
	#elif ARDUINO
	//	#define	LED1_OUT	15				// 赤色ＬＥＤ(エラー用)用デジタルポート(15=analog 1)
	//	#define	LED2_OUT	16				// 緑色ＬＥＤ(動作確認用)用デジタルポート(16=analog 2)
	//	#define	LCD_EN		 6				// 液晶用電源デジタルポート
	//	#define	BUTN		14				// ボタンの接続ポート(14 = analog 0)
		#ifdef LITE
			#define		API_SIZE	48		// 受信用APIデータ長(32～255)
			#define		API_TXSIZE	24		// 送信用APIデータ長(32～255)
			#define		CALL_SIZE	16		// コールバック関数xbee_rx_call用戻りデータ(9～256)
			#define		XB_AT_SIZE	16		// ATコマンドの最大長
		#else
			#define		CACHE_RES	3		// 応答時のキャッシュ数（無効にするには定義を消す）
			#define		API_SIZE	64		// 受信用APIデータ長(32～255)
			#define		API_TXSIZE	64		// 送信用APIデータ長(32～255)
			#define		CALL_SIZE	32		// コールバック関数xbee_rx_call用戻りデータ(9～256)
			#define		XB_AT_SIZE	32		// ATコマンドの最大長
		#endif
		#define	LIGHT			1
		#define	TEMP			2
		#define	HUMIDITY		3
		#define	WATT			4
		#define	BATT			5
		#define	DISABLE			0
		#define	VENDER			1
		#define	AIN				2
		#define	DIN				3
		#define	DOUT_L			4
		#define	DOUT_H			5
	#else // PC
		// #define DEBUG					// デバッグモード
		// #define DEBUG_RX					// 受信パケットの表示
		#define		CACHE_RES	10			// 応答時のキャッシュ数（無効にするには定義を消す）
		#define		ERRLOG
		#define		API_SIZE	255			// 受信用APIデータ長(32～255)
		#define	API_TXSIZE	64				// 送信用APIデータ長(32～255)
		#define	CALL_SIZE	64				// コールバック関数xbee_rx_call用戻りデータ(9～256)
		#define		XB_AT_SIZE	32			// ATコマンドの最大長
	#endif
	#define		TIME_DEL	3				// デリミタ検出のタイムアウト時間(秒)
	#define		MODE_AUTO	0x00			// 自動受信モード
	#define		MODE_GPIN	0x92			// GPI data を受信するモード
	#define		MODE_UART	0x90			// UART data を受信するモード
	#define		MODE_UAR2	0x91			// UART data を受信するモード２(AO=1)
	#define		MODE_SENS	0x94			// XB Sensorを受信するモード(1wire専用→通常のSensorはATISを使用)
	#define		MODE_IDNT	0x95			// Node Identifyを受信するモード
	#define		MODE_RES	0x88			// ローカルATコマンドの結果を受信
	#define		MODE_RESP	0x97			// リモートATコマンドの結果を受信(仕様書はATNDで説明ATISもこれ)
	#define		MODE_MODM	0x8A			// Modem Statusを受信
	#define		MODE_BATT	0xE1			// (独自定義)バッテリステータス RAT%Vの応答時
				// XBeeのFrame Typeに準拠する。
				// 注意：モードを増やしたときはxbee_from_acumとxbee_rx_call内の対応を追加すること
				// 独自定義の時はxbee_rx_call内のみ。
				// MODE値はenum定義にしない。
				
	#define		STATUS_OK		0x00		// ATコマンドの結果がOK
	#define		STATUS_ERR		0x01		// ATコマンドの結果がERROR
	#define		STATUS_ERR_AT	0x02		// 指定されたATコマンドに誤りがある
	#define		STATUS_ERR_PARM	0x03		// 指定されたパラメータに誤りがある
	#define		STATUS_ERR_AIR	0x04		// リモートATコマンドの送信の失敗(相手が応答しない)
	
	#define		MODM_RESET		0x01		// ローカルのXBeeがリセットした
	#define		MODM_WATCHDOG	0x02		// ローカルのXBeeがWatch dogタイマーによってリセットした
	#define		MODM_JOINED		0x03		// (RouterまたはEnd Deviceで使用しているときに)ネットワークJoinした
	#define		MODM_LEFT		0x04		// ネットワークからdis_assosiateした
	#define		MODM_STARTED	0x06		// (coordinatorで使用しているときに)Coordinatorを開始した
	
	#define		DEV_TYPE_XBEE	0x00		// XBeeモジュール
	#define		DEV_TYPE_RS232	0x05		// RS-232Cアダプタ
	#define		DEV_TYPE_SENS	0x07		// Sensor (1wire専用)
	#define		DEV_TYPE_PLUG	0x0F		// SmartPlug

	#define		NET_ADR		FFFE			//ネットワークアドレス
#endif

/*********************************************************************
型の定義とグローバル変数の宣言
*********************************************************************/
#ifndef XB_GLOBAL_H
	#define XB_GLOBAL_H
	typedef unsigned char byte;				// Arduinoでも必要
	#ifdef H3694
		byte		TIMER_SEC	=	0	;	//ＲＴＣカウント用１秒単位
		char sci_tx[SCI_SIZE];				// シリアル用
		char sci_rx[SCI_SIZE];
	#elif ARDUINO
		#define	TIMER_SEC	time1s256()
	#else // PC
		#define	TIMER_SEC	time1s256()		// TIMER_SECのカウントアップの代わり
		byte LED1_OUT;
		byte LED2_OUT;
		byte LCD_EN;
		int fd;
		struct termios oldtio; /* current serial port settings
		                        (現在のシリアルポートの設定を待避)*/
		byte *receive_buffer; 
		byte xbee_com_port;
	#endif

	#ifdef ARDUINO
		#ifdef LCD_H
			#ifndef ADAFRUIT
				// 通常のキャラクタLCDの場合
				LiquidCrystal xbee_ardlcd(8, 9, 4, 5, 6, 7);
								//LCD設定 rs en d0 d1 d2 d3
			#else
				// Adafruit I2C接続LCDの場合(Adafruit_RGBLCDShieldライブラリが必要)
				Adafruit_RGBLCDShield xbee_ardlcd = Adafruit_RGBLCDShield();
			#endif
		#endif
		
		// 構造体の宣言 2013.04.07
		typedef struct{
			byte MODE;				// 受信モード(Frame Type)
			byte FROM[8];			// 送信元IEEEアドレス
			byte AT[2];				// ATコマンド
			byte STATUS;			// 応答結果(0:OK 1:ERROR)／AT結果／UART状態
			union {					// GPIOデータ
				byte BYTE[2];
				struct {			// バイト毎に下位ビットから代入(リトルエンディアン)
					byte D0	:1;	byte D1	:1;	byte D2	:1;	byte D3	:1; // BYTE[1]
					byte D4	:1;	byte D5	:1;	byte D6	:1;	byte D7	:1;
					byte 	:1;	byte 	:1;	byte D10:1;	byte D11:1;	// BYTE[0]
					byte D12:1;	byte 	:1;	byte 	:1;	byte 	:1;
				} PORT;
			} GPI;
			// 	byte GPI[2];			// GPIOデータ
			unsigned int ADCIN[4];	// ADCデータ
			byte DATA[CALL_SIZE];	// ペイロードデータ／ZCLヘッダ＋受信データ
		} XBEE_RESULT;				// 構造体の型名
		
	#else
		enum xbee_sensor_type{ LIGHT,TEMP,HUMIDITY,WATT,BATT,PRESS,VALUE,TIMES,NA };	// センサタイプの型
		enum xbee_port_type{ DISABLE=0, VENDER=1, AIN=2, DIN=3, DOUT_L=4, DOUT_H=5 };
																// GPIOの設定の型
		typedef struct{
			byte MODE;				// 受信モード(Frame Type)
			byte FROM[8];			// 送信元IEEEアドレス
			byte SHORT[2];			// 送信元ショートアドレス
			byte AT[2];				// ATコマンド
			byte ID;				// 応答パケットID(Frame ID)
			byte STATUS;			// 応答結果(0:OK 1:ERROR)／AT結果／UART状態
			union {					// GPIOデータ
				byte BYTE[2];
				struct {
					#ifdef H3694	// H8ではバイト毎に上位ビットから代入(ビッグエンディアン)
					byte D7	:1;	byte D6	:1;	byte D5	:1;	byte D4	:1; // BYTE[1]
					byte D3	:1;	byte D2	:1;	byte D1	:1;	byte D0	:1;
					byte 	:1;	byte 	:1;	byte 	:1;	byte D12:1;	// BYTE[0]
					byte D11:1;	byte D10:1;	byte 	:1;	byte 	:1;
					#else			// PCではバイト毎に下位ビットから代入(リトルエンディアン)
					byte D0	:1;	byte D1	:1;	byte D2	:1;	byte D3	:1; // BYTE[1]
					byte D4	:1;	byte D5	:1;	byte D6	:1;	byte D7	:1;
					byte 	:1;	byte 	:1;	byte D10:1;	byte D11:1;	// BYTE[0]
					byte D12:1;	byte 	:1;	byte 	:1;	byte 	:1;
					#endif
				} PORT;
			} GPI;
			unsigned int ADCIN[4];	// ADCデータ
			byte ZCL[6];			// [0]送信元EndPoint, [1]宛先EndPoint, [2-3]クラスタID, [4-5]プロファイルID
			byte DATA[CALL_SIZE];	// ペイロードデータ／ZCLヘッダ＋受信データ
		} XBEE_RESULT;
	#endif
	#ifdef CACHE_RES
		byte CACHE_MEM[CACHE_RES][API_SIZE];
		byte CACHE_COUNTER = 0;
	#endif
#endif

/*********************************************************************
スタティック変数の宣言
*********************************************************************/

/* エラーログ用 */
#ifdef ERRLOG
static byte		TIMER_ERR	=	0	;		//エラー経過時間１秒単位
static char		ERR_LOG[API_TXSIZE-18];
static byte		ERR_CODE=0x00;
#endif

/* IEEEアドレス(最小限の通信対象をライブラリ側で保持する)／複数のデバイスへの対応はアプリ側で行う*/
static byte ADR_FROM[]=		{0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF};	//差出人のIEEEアドレス(変更可)

// 以下にお手持ちのXBeeのアドレスを予め設定しておくと毎回の検索が不要です。
static byte ADR_DIST[]=		{0x00,0x13,0xA2,0x00,0x00,0x00,0x00,0x00};	//宛先のIEEEアドレス(変更可)

/*ショートアドレス／本ライブラリでの宛先指定はIEEEのみを使う*/
static const byte SADR_BC[]=	{0xFF,0xFE};		//ブロード(ショート)アドレス
static byte PACKET_ID = 0;							//送信パケット番号

/*********************************************************************
ハードウェア
*********************************************************************/

void port_init(void){
	#ifdef H3694
	/*ポート1         76543210*/
	IO.PMR1.BYTE  = 0b00000000;     // モード(P1,5)     入出力=0  その他=1
	IO.PCR1       = 0b11110110;     // 入出力設定       入力  =0  出力  =1  B3=リザーブ
	IO.PUCR1.BYTE = 0b00000000;     // プルアップ(P1,5) しない=0  する  =1
	IO.PDR1.BYTE  = 0b00000000;     // アクセス         Ｌ出力=0  Ｈ出力=1

	/*ポート8         76543210*/	// 秋月 H8 Tiny I/O BOARD TERA2 [K-00207]用
	IO.PCR8       = 0b11111011;     // 入出力設定       入力  =0  出力  =1
	IO.PDR8.BYTE  = 0b00000000;     // アクセス         Ｌ出力=0  Ｈ出力=1
	#elif ARDUINO
		// pinMode(LED1_OUT, OUTPUT);
		// pinMode(LED2_OUT, OUTPUT);
		// pinMode(LCD_EN,   OUTPUT);
		// pinMode(BUTN,     INPUT);
	#else //PC
	#endif
}

/* タイマー初期化 */
void timer_sec_init(void){
	#ifdef H3694
	DI; 
    TA.TMA.BYTE     =0b00001000;  /* 時計用クロック  */
/*                     |  |||-|__ 分周比 000～111(高速時) 000～011(低即時)
             固定値 ___|--||             000:0.5120 sec.  000 1000 msec.
                           |             001:0.2560 sec.  001  500 msec.
     高速=0, 低速=1 _______|             100:0.0160 sec.  010  250 msec.
                                       111:0.0005 sec.  011   31.25 msec.*/

	IRR1.BIT.IRRTA  =0;           /* タイマーＡ割込みフラグのリセット */
	IENR1.BIT.IENTA =1;           /* タイマーＡ割込みを利用可能にする */
	EI;
	#endif
}

/* AKI H8 TINY IO BOARD TERA2 用/PC用の接続デバイス設定*/
byte led_red( const byte in ){
	#ifdef ARDUINO
		// if( in == 0 )	digitalWrite( LED1_OUT, LOW );
		// else 			digitalWrite( LED1_OUT, HIGH );
		// return( (byte)digitalRead(LED1_OUT) );
		return( 0 );
	#else
		if		( in == 0 )	LED1_OUT=0;
		else if	( in == 1 )	LED1_OUT=1;
		return( LED1_OUT );
	#endif
}
byte led_green( const byte in ){
	#ifdef ARDUINO
		// if( in == 0 )	digitalWrite( LED2_OUT, LOW );
		// else 			digitalWrite( LED2_OUT, HIGH );
		// return( (byte)digitalRead(LED2_OUT) );
		return( 0 );
	#else
		if		( in == 0 )	LED2_OUT=0;
		else if	( in == 1 )	LED2_OUT=1;
		return( LED2_OUT );
	#endif
}

byte button( void ){
	#ifdef H3694
		return( BUTN );
	#elif ARDUINO
		// return( (byte)digitalRead(BUTN) );
		return( 0 );
	#else // PC
		// char c='\0';
		// if (kbhit()) c = getch();
		return( 0 );
	#endif
}

void lcd_enable( const byte in ){
	#ifdef H3694
		LCD_EN = in;
	#endif
}

byte time1s256(){
	#ifdef H3694
		return(0x00);
	#elif ARDUINO
		return( (byte)(millis()/1000) );
	#else //PC
		// char c='\0';
		// if (kbhit()) c = getch();
		time_t sec;
		time( &sec );
		return( (byte)sec );
	#endif
}

/*	割り込み処理	*/
void int_timera(void){
	led_green( TIMER_SEC & 0x01 );	// LEDの正常点滅
	#ifdef ERRLOG
		if( led_red( 0xFF ) == 1 ) TIMER_ERR++;		// エラー秒数(LED_赤でエラー検出)
	#endif
	#ifdef H3694
		TIMER_SEC++;				// タイマーのカウントアップ
		IRR1.BIT.IRRTA=0;			// タイマーA割込フラグのリセット
	#endif
}

byte timera(void){
	#ifdef H3694
		return( (byte)TA.TCA );
	#elif ARDUINO
		return( (byte)( (millis()/4)%256 ) );
	#else //PC
		return(	(byte)(clock()/(CLOCKS_PER_SEC/256))  );
	#endif
}

/* ミリ秒待ち250ms 入力範囲＝4～250 ms */
void wait_millisec_250( byte ms ){
	#ifdef H3694
		byte counter;
		
		if( ms < 0x04 ) ms = 0x04;
		counter = timera() + (byte)( ms>>2 );
		if( counter == timera() ) counter++;
		while( counter != timera() );
	#elif ARDUINO
		delay( (unsigned long) ms );
	#else //PC
	
	#endif
}

/* ミリ秒待ち 入力範囲＝4～30,000 ms */
void wait_millisec( const int ms ){
	#ifdef H3694
		byte loops;
		if( ms < 250 ){
			wait_millisec_250( (byte)ms );
		}else{
			loops = (byte)( ms / 250);
			wait_millisec_250( (byte)(ms-loops*250) );
			while( loops > 0x00 ){
				wait_millisec_250( 0xFA );
				loops--;
			}
		}
	#elif ARDUINO
		delay( (unsigned long) ms );
	#else // PC
		time_t target;
		
		target = (time_t)(clock()/(CLOCKS_PER_SEC/1000)) + (time_t)ms;
		if( target >= (time_t)ms ){
			while( (time_t)(clock()/(CLOCKS_PER_SEC/1000)) <= target );
		}else{
			while( (time_t)(clock()/(CLOCKS_PER_SEC/1000)) > (time_t)ms );		// クロックがリセットされるまで待つ
			while( (time_t)(clock()/(CLOCKS_PER_SEC/1000)) <= target );
		}
	#endif
}

/* 経過時間測定＝4～1000 ms 以内 単位は1/256秒毎 */
byte past_time(const byte time_from){
	return( timera() - time_from );
}

/* ADCの有効ポート数を調べる ADC1～3のみ 入力=バイトデータ 応答0～3個 */
byte xbee_adc_count( byte d ){
	return( ((d>>1)&0x01)+((d>>2)&0x01)+((d>>3)&0x01) );
}

/* シリアル通信 */

#ifndef ARDUINO
#ifndef H3694
int open_serial_port(char *modem_dev){
/*
PC-UNIX関連ドキュメント
「シリアルポートプログラミング」
http://www006.upp.so-net.ne.jp/kasuya/linux/serial_io_programing.html
writer:粕谷友章 kasuya@pd5.so-net.ne.jp 
*/
    struct termios newtio;
    speed_t speed = B9600;
    /* Open modem device for reading and writing and not as controlling tty */
    /* 読み書きの為にモデムデバイスをオープンする。ノイズによってCTRL-Cが
              たまたま発生しても接続が切れないようにtty制御はしない */
    // fd=open(modem_dev,O_RDWR | O_NOCTTY);
    fd=open(modem_dev,O_RDWR);
    if(fd < 0){
        perror(modem_dev);
        return -1;
    }else{
	    tcgetattr(fd,&oldtio);	// シリアルポートの設定の退避
	    /* Clear the struct for new port settings */ 
	    /* 制御文字の初期化を行う */
	    newtio.c_iflag = 0;
	    newtio.c_oflag = 0;
	    newtio.c_cflag = 0;
	    newtio.c_lflag = 0;
	    newtio.c_line = 0;
	    bzero(newtio.c_cc,sizeof(newtio.c_cc));
	    /* Settings for new port
	      BAUDRATE : Set bps rate. You could also use cfsetispeed and cfsetospeed.
	      ボーレートの設定。cfsetispeed,cfsetospeedも使用できる
	      CRTSCTS  : Output hardware flow control ( only used if the cable has all
	                  necessary lines. See sect. 7 of Serial-HOWTO )
	             出力のハードウェアフロー制御(必要な結線が全てされているケースのみ)
	      CS8      : 8n1 ( 8bit,no parity,1 stopbit)
	      CLOCAL   : local connection,no modem control
	      CREAD    : enable receiving characters
	                    受信文字を有効にする
	    */
	    cfsetispeed( &newtio, speed );
	    cfsetospeed( &newtio, speed );
	    newtio.c_cflag = BAUDRATE | CLOCAL | CREAD ;
		newtio.c_cflag &= ~CSIZE; // キャラクタ・サイズ数のビット部分だけ0にセット
		newtio.c_cflag |= CS8;    // データビット数を8にする
		// newtio.c_iflag = IGNPAR;// IGNPAR:パリティエラーの文字は無視
	    newtio.c_oflag = 0;     // Raw output (Rawモードでの出力) 0=無効
	    newtio.c_lflag = 0;     // Set input mode (カノニカル入力) 0=非カノニカル
	    newtio.c_cc[VMIN] = 0;  // read single char received　n文字来るまでreadをブロック
	    newtio.c_cc[VTIME] = 00; // inter-character timer　0=未使用 2=20ms
	    /* Now clean the modem line and activate the settings for the port */
	    /* モデムラインをクリアする */
	    tcflush(fd,TCIFLUSH);
	    /* 新しい設定を適用する */
	    tcsetattr(fd,TCSANOW,&newtio);
	}
    return 0;
}
void close_serial_port(void){
    tcsetattr(fd,TCSANOW,&oldtio);
    close(fd);
}
#endif	// not H3694
#endif	// not ARDUINO

/* シリアルの初期化 */
byte sci_init( byte port ){
	#ifdef H3694
		SCI3_INIT(br9600, sci_tx, SCI_SIZE, sci_tx, SCI_SIZE);
		EI;									// 割り込み許可
		return(1);
	#elif ARDUINO
		#ifdef LEONARDO
			Serial1.begin(9600);
		#else
			Serial.begin(9600);
		#endif
		return(1);
	#else
		char modem_dev[11] = "/dev/ttyS0";
		
		if( port <= 10){
			modem_dev[9] = (char)( port - 1 + (byte)'0' );
			if( open_serial_port( modem_dev ) ){
				wait_millisec( 100 );
				close_serial_port();	// open出来ていないが念のために閉じる
				wait_millisec( 100 );
				fprintf(stderr,"Failed serial COM%d (%s)\n",port,modem_dev);
				port = 0;
			}else{
				fprintf(stderr,"Serial port = COM%d (%s)\n",port,modem_dev);
				xbee_com_port = port;
			}
		}else{
			fprintf(stderr,"ERR:sci_init port=%d\n",port);
			port = 0;
		}
		return( port );
	#endif
}

/* シリアル送受信バッファクリア */
void sci_clear(void){
	#ifdef H3694
		SCI3_IN_DATA_CLEAR();
		SCI3_OUT_DATA_CLEAR();
	#elif ARDUINO
		#ifdef LEONARDO
			Serial1.flush();
		#else
			Serial.flush();
		#endif
	#else
		tcflush(fd,TCIOFLUSH);	// 正しく動いているように見えない
	#endif
}

/* シリアル受信 */
byte sci_read(byte timeout){
	#ifdef H3694
		byte timer;
		byte ret=0;
		timer = timera() + (timeout)+1;		// timeout[ms] = timer/256*1000
		while( timer != timera() && SCI3_IN_DATA_CHECK() < 1 );
		if( SCI3_IN_DATA_CHECK() ) ret=(byte)SCI3_IN_DATA();
		return( ret );
	#elif ARDUINO
		int value = 0;
		byte timer;
		timer = timera() + (timeout)+1;		// timeout[ms] = timer/256*1000
		led_green(0);
		#ifdef LEONARDO
			while( timer != timera() && Serial1.available() <= 0 );
			if( Serial1.available() > 0 ) value = Serial1.read();
		#else
			while( timer != timera() && Serial.available() <= 0 );
			if( Serial.available() > 0 ) value = Serial.read();
		#endif
		led_green(1);
		return( (byte)value );
	#else
		/* 受信の有無の判断に複数FDの待ち受け関数selectを使用する。
		参考文献
		http://linuxjm.sourceforge.jp/html/LDP_man-pages/man2/select.2.html#index
		http://www.h3.dion.ne.jp/~unisoft/answer/sample01.html
		http://archive.linux.or.jp/JF/JFdocs/Serial-Programming-HOWTO-3.html
		*/
		byte c;
		struct timeval tv;
		fd_set readfds;
		
		FD_ZERO(&readfds);
		FD_SET( fd , &readfds);
		tv.tv_sec = 0;
		tv.tv_usec = timeout*1000;
		if( select( (fd+1), &readfds, NULL, NULL ,&tv ) ){
			read(fd,(char *)&c,1);
		}else{
			c = 0x00;
		}
		return( c );
	#endif
}

/* シリアル送信バッファが空になるのを待つ */
byte sci_write_check(void){
	#ifdef H3694
		byte timer;
		timer = timera() + 0x7F;	// timeout = 500ms
		while( (timer != timera()) && ( SCI3_OUT_DATA_CHECK() < 1 ) );
		return( (byte)SCI3_OUT_DATA_CHECK() );
	#elif ARDUINO
		return( 1 );	// 関数があるかもしれないので、そのうち要調査＆確認
	#else
		tcdrain( fd );	// 正しく動いているように見えない
		return( 1 );
	#endif
}

/* シリアル送信 */
byte sci_write( char *data, byte len ){
	byte ret=1;	// 戻り値 0でエラー

	#ifdef H3694
		SCI3_OUT_STRINGB( data , (short)len );	// 戻り値なし
	#elif ARDUINO
		byte i;
		for(i=0;i<len;i++){
			#ifdef LEONARDO
				ret = Serial1.write( data[i] );	// 戻り値は書き込みバイト数
			#else
				ret = Serial.write( data[i] );	// 戻り値は書き込みバイト数
			#endif
			if( ret == 0 ){
				i = len;
			}
		}
	#else // PC
		byte i;
		for(i=0;i<len;i++){
			if(write(fd,&data[i],1) != 1){
				fprintf(stderr,"sci_write ERR:d[%02d]=0x%02x\n",i,(byte)data[i]);
				ret = 0;
			}
		}
	#endif
	return( ret );
}

/* string byte操作 */
void strcopy(char *s1, const char *s2){	// string.hが含まれる場合はstrcpyを使用
    while( *s2 != 0x00 ) *s1++ = *s2++;
    *s1 = 0x00;
}
void bytecpy(byte *s1, const byte *s2, byte size){
	byte i;
	for(i=0; i< size ;i++ ){
		s1[i] = s2[i];
	}
}
byte bytecmp(byte *s1, const byte *s2, byte size){	// strcmpのような大小比較は無い
	byte i=0;										// 同一なら0を応答
	for(i=0; i< size ;i++ ){
		if( s1[i] != s2[i] ) return(1);
	}
	return(0);
}

/* LCD用関数 for ARDUINO */
#ifdef ARDUINO
	void lcd_cls(void){
		#ifdef LCD_H
			xbee_ardlcd.clear();
		#endif
	}

	void lcd_home(void){
		#ifdef LCD_H
			xbee_ardlcd.home();
		#endif
	}

	void lcd_control(byte disonoff, byte curonoff, byte curblink){
	}


	void lcd_goto(const byte mesto){
		byte row=0;
		
		switch( mesto ){
			case LCD_ROW_1: row=0; break;
			case LCD_ROW_2: row=1; break;
			case LCD_ROW_3: row=2; break;
			case LCD_ROW_4: row=3; break;
		}
		#ifdef LCD_H
			xbee_ardlcd.setCursor(0,(int)row);
		#endif
	}

	void lcd_shift(const byte data){
		#ifdef LCD_H
			xbee_ardlcd.write(' ');
		#endif
	}

	void lcd_putch(const char data){
		#ifdef LCD_H
			xbee_ardlcd.write( data );
		#endif
	}

	void lcd_putstr(const char *data){
		#ifdef LCD_H
			while(*data != 0) {
			    xbee_ardlcd.write(*data);
			    data++;
			}
		#endif
	}

	void lcd_disp_bin(const byte x){
		#ifdef LCD_H
			// xbee_ardlcd.print( x, BIN );
			byte i;
			for (i=128;i>0;i>>=1){
				if ((x&i)==0){
					lcd_putch('0');
				}else{
					lcd_putch('1');
				}
			}
		#endif
	}

	void lcd_disp_hex(const byte i){
		#ifdef LCD_H
			// xbee_ardlcd.print( i, HEX );
			byte hi,lo;
			hi=i&0xF0;               // High nibble
			hi=hi>>4;
			hi=hi+'0';
			if (hi>'9'){
				hi=hi+7;
			}
			lo=(i&0x0F)+'0';         // Low nibble
			if (lo>'9'){
				lo=lo+7;
			}
			lcd_putch((char)hi);
			lcd_putch((char)lo);
		#endif
	}

	void lcd_disp_1(const unsigned int x){
		#ifdef LCD_H
			if (x<10){
				xbee_ardlcd.write((char)(x+0x30));
			}else if (x<16){
				xbee_ardlcd.write((char)(x-10+'A'));
			}else{
				xbee_ardlcd.write('X');
			}
		#endif
	}

	void lcd_disp_2(unsigned int x){
		#ifdef LCD_H
			unsigned int y;
			if (x<100){
				y=x/10;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*10);
				xbee_ardlcd.write((char)(x+0x30));
			}else{
				xbee_ardlcd.print("XX");
			}
		#endif
	}

	void lcd_disp_3(unsigned int x){
		#ifdef LCD_H
			unsigned int y;
			if (x<1000){
				y=x/100;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*100);
				y=x/10;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*10);
				xbee_ardlcd.write((char)(x+0x30));
			}else{
				xbee_ardlcd.print("XXX");
			}
		#endif
	}

	void lcd_disp_5(unsigned int x){
		#ifdef LCD_H
			unsigned int y;
			if (x<=65535){
				y=x/10000;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*10000);
				y=x/1000;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*1000);
				y=x/100;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*100);
				y=x/10;
				xbee_ardlcd.write((char)(y+0x30));
				x-=(y*10);
				xbee_ardlcd.write((char)(x+0x30));
			}else{
				xbee_ardlcd.print("XXXXX");
			}
		#endif
	}

	void lcd_init(void){
		#ifdef LCD_H
			xbee_ardlcd.begin(20, 4);			// 液晶の桁数×行数の設定
			xbee_ardlcd.clear();				// 表示クリア
		#endif
	}
#endif

/*********************************************************************
XBeeドライバ関数
*********************************************************************/

/*
	       00 01 02 03 04 05 06 07 08....
	ATNJ = 7E 00 05 08 01 4E 4A FF 5F
	      |  | len |mo|FI| NJ=0xFF|CS|
	      |  |     |de|  |        |__|___ Check Sum
	      |  |     |  |  |________|______ AT コマンド
	      |  |     |  |__|_______________ Frame ID
	      |  |     |__|__________________ AT=0x08 Remote=0x17
	      |  |_____|_____________________ Data Lengrh (ATコマンド+2文字)
	      |__|___________________________ 固定値

	char *at "AT"	ATコマンド			len=4バイト～最大255 (フレーム8バイト～)
	         "RAT"	リモートATコマンド	len=15バイト～最大255 (フレーム19バイト～)
	         "TX"	データ送信コマンド	len=15バイト～最大255 (フレーム19バイト～)
                                        ※API_SIZE=32の時valueは12バイトまで
*/

byte xbee_at_tx(const char *at, const byte *value, const byte value_len){
/*
	処理：リモートＡＴコマンドの送信を行うXBeeドライバ部
	入力：ATコマンドat[] ＝ "AT**"はローカルATで、"RAT***"がリモートＡＴ
	　　　　　　　　　　　　TXがデータ送信モード
	　　　データvalue[]　＝ 各ＡＴコマンドで引き渡すデータ値
	　　　value_len　　　＝ その長さ
	戻り値：送信したAPIサービス長。送信しなかった場合は0
*/
	char data_api[API_TXSIZE];
	byte i;
	byte len;				// APIサービス長
	byte check=0xFF;		// チェックサム
	byte data_position=5;	// 送信データdata_api[]の何処にvalue[]を入れるか
	byte ret=0;
	
	if( PACKET_ID == 0xFF ){
		PACKET_ID=0x01;
	}else{
		PACKET_ID++;
	}
	len=0;
	switch( at[0] ){
		case 'A':
			if( at[1]=='T'){
				data_api[3]=(char)0x08;			// ATコマンドモード
				data_api[4]=(char)PACKET_ID;		// フレームID
				data_api[5]=(char)at[2];			// ATコマンド上位
				data_api[6]=(char)at[3];			// ATコマンド下位
				data_position=7;	
				len=4;						// サービスデータにMD+FI+AT(2)バイトが入る
			}
			break;
		case 'R':
		case 'S':
			if( at[1]=='A' && at[2]=='T'){
				data_api[3]=(char)0x17;		// リモートATコマンドモード
				if( at[0] == 'R') 
					data_api[4]=(char)PACKET_ID;		// フレームID (at="RATxx")
				else
					data_api[4]=0x00;					// IDなし（at="SATxx")
				for( i=5 ; i<=12 ; i++)  data_api[i]=(char)ADR_DIST[i-5];
				for( i=13 ; i<=14 ; i++) data_api[i]=(char)SADR_BC[i-13];
				data_api[15]=(char)0x02;	// apply changes
				data_api[16]=(char)at[3];	// ATコマンド上位
				data_api[17]=(char)at[4];	// ATコマンド下位
				data_position=18;			// value[]を入れる場所
				len=15;						// サービスデータにMD+FI+ADR(8)+SAD(2)+OPT+AT(2)が入る
			}
			break;
		case 'T':
			if( at[1]=='X'){
				data_api[3]=(char)0x10;			// TXデータ送信モード
				data_api[4]=(char)0x00;			// フレームIDを使用しない(no responce)
				for( i=5 ; i<=12 ; i++)  data_api[i]=(char)ADR_DIST[i-5];
				for( i=13 ; i<=14 ; i++) data_api[i]=(char)SADR_BC[i-13];
				data_api[15]=(char)0x00;		// ZigBeeホップ数
				data_api[16]=(char)0x00;		// 暗号化＝しない
				data_position=17;
				len=14;						// サービスデータにMD+FI+ADR(8)+SAD(2)+OPT(2)が入る
			}
			break;
		default:
			break;
	}
	if( len ){
		data_api[0]=(char)0x7E;				// デリミタ
		data_api[1]=(char)0x00;				// パケット長の上位(送らない前程)
		for( i=3 ; i < data_position ; i++) check -= (byte)data_api[i];
		if( value_len > 0 ){
			for( i=0 ; i<value_len; i++){
				data_api[data_position + i] = (char)value[i];
				check -= (byte)data_api[data_position + i];
				len++;
			}
		}
		data_api[2]    =(char)len;
		data_api[len+3]=(char)check;
		check = sci_write_check();		// 以降 checkはシリアルバッファ確認に使用する
		/*シリアルデータ送信 */
		if(  check > 0 ){
			if( sci_write( data_api, (byte)(len+4) ) == 0 ){
				/* シリアルリセット */
				#ifndef H3694
				#ifndef ARDUINO // PC
					wait_millisec( 100 );
					close_serial_port();		// シリアルを閉じる
					wait_millisec( 300 );
					printf("RESET serial\n");
					sci_init( xbee_com_port );	// 再度オープン
					wait_millisec( 300 );
					sci_write( data_api, (byte)(len+4) );	// 再送信
				#endif
				#endif
			}
			ret=len+3;
		}else{
			led_red( 1 );
			#ifdef ERRLOG
				strcopy( ERR_LOG , "ERR:TX Buffer Over" );
				ERR_CODE = check;
			#endif
			ret=0;
		}
	}
	return( ret );
}

byte xbee_at_rx(byte *data){
/*
	リモートＡＴコマンドの応答を受信するXBeeドライバ部
	処理：XBeeからの受信データをdata[]へ代入(応答)する
	入出力：APIデータdata[] 前３バイトは'7E'+len(2) data[0]が0x00の場合はタイムアウト
	リターン：APIサービス長、0はタイムアウト
*/
	byte i;
	byte len;			// APIサービス長－３ (APIフレームの前３バイトとチェックサム１バイトを除く)
	unsigned int leni;	// 実際のAPIサービス長と使用するAPIサービス長の差(データ破棄用)
	byte check = 0xFF; // チェックサム
	byte ret=0;

	data[0] = 0x00;
	
	/* 受信処理 */
	data[0] = sci_read( 1 );				// 1ms待ち受けで受信
	if( data[0] == 0x7E ) {					// 期待デリミタ0x7E時
		for( i=1;i<=2;i++ ){
			data[i] = sci_read( 50 );
		}
		if(data[1] == 0x00) len = data[2];
		else len = 0xFF - 4;		// API長が255バイトまでの制約(本来は64KB)
		if( len > (API_SIZE-4) ) len = API_SIZE-4;
		leni = (unsigned int)data[1] * 256 + (unsigned int)data[2] - (unsigned int)len;
			// 通常は0。lenが本来の容量よりも少ない場合に不足分が代入されれる
		for( i=0 ; i <= len ; i++){	// i = lenはチェックサムを入力する
			data[i+3] = sci_read( 50 );
			if( i != len) check -= data[i+3];	// チェックサムのカウント
		}
		while( leni > 0 ){
			data[len+3] = sci_read( 50 );	// データの空読み(lenは固定)
			if( leni != 1 ) {
				check -= data[len+3];		// leni=0の時はCheck sumなので減算しない
			}
			leni--;
		}
		if( check == data[len+3] ) ret = len +3;
		else ret = 0;
		#ifdef DEBUG_RX
			lcd_cls(); lcd_goto(LCD_ROW_1);
			lcd_putstr("->");
			for( i=0 ; i <= len+3 ; i++){
				lcd_disp_hex( data[i] );
				if( i == 8 ) lcd_goto(LCD_ROW_2);
				if( i == 18 ) lcd_goto(LCD_ROW_3);
				if( i == 28 ) lcd_goto(LCD_ROW_4);
				if( i == 38 ) lcd_goto(LCD_ROW_1);
			}
			lcd_goto(LCD_ROW_4);
			lcd_putstr("ID=");
			lcd_disp_hex( PACKET_ID );
			lcd_putstr(":");
			lcd_disp_hex( data[4] );
			if( check != data[len+3]){
				lcd_putstr(" ER=");
			}else{
				lcd_putstr(" OK=");
			}
			lcd_disp_hex( check );
			lcd_putstr(":");
			lcd_disp_hex( data[len+3] );
		#endif
	}
	return( ret );
}

byte xbee_from_acum( const byte *data ){
/*
	処理：受信データの差出人をグローバル変数へ登録 ※xbee_at_rxでは登録しない
	入力：data[] APIデータ
	出力：byte 受信データの種別mode値を戻り値に代入
	　　　受信データの差出人をグローバル変数ADR_FROMに代入
	再起動で8Aのモード応答あり
*/
	byte i;
	byte ret=0;

	if( data[3]==MODE_UART			// 0x90 UART Receive
	 || data[3]==MODE_UAR2			// 0x91 UART AO=0
	 || data[3]==MODE_GPIN			// 0x92 GPI data
	 || data[3]==MODE_SENS			// 0x94 XB Sensor
	 || data[3]==MODE_IDNT){		// 0x95 Node Identify
		for(i=0;i<8;i++) ADR_FROM[i]=data[4+i];
		ret = data[3];
	}else if( 
		data[3]==MODE_RES			// 0x88 ローカルATコマンドの結果
	 || data[3]==MODE_RESP			// 0x97 リモートATコマンドの結果
	 || data[3]==MODE_MODM){  		// 0x8A Modem Statusを受信
		ret = data[3];
	}else{
		led_red( 1 );
		#ifdef ERRLOG
			strcopy( ERR_LOG , "ERR:xbee_from" );
			ERR_CODE = data[3];
		#endif
		ret = 0;
	}
	return( ret );
}

byte xbee_gpi_acum( byte *data ){
/*	リモート先(ADR_FROMに入力)のGPIOの入力値を応答する。
	リモート先は（こちらから呼ばなくても）GPIOの変化などで自動送信する設定にしておく必要がある。
	具体的にはリモート先をATIC設定するなど。本演算関数はxbee_rx_callから呼ばれる。
	port:	port指定	IO名	ピン番号			USB評価ボード(XBIB-U-Dev)
			port= 1		DIO1	XBee_pin 19 (AD1)	     SW2
			port= 2		DIO2	XBee_pin 18 (AD2)	     SW3
			port= 3		DIO3	XBee_pin 17 (AD3)	     SW4
	out:	port 1～7の入力値をバイトで応答。
			上位バイトのポートには対応しない
			DIOのport1～7がオフでかつADCが有効の場合は有効ADC(1～3の最も若い番号)のAD変換結果を応答する。
			ADC結果は8ビットに間引かれる。電圧は0～1.2Vに対応する。以下でADC電圧を得ることが可能。
					(unsigned int)xbee_gpi_acum(data)/255*1200 [mV]
	注意１：DIO/ADCの切り換え方法：DIOのport1～7が一つでも有効であればDIOとして動作します。
			port1～7のDIOが全て無効でADCが有効であれば有効なADC(1～3の最も若い番号)が動作します。
			port1～7のDIOとADC1～3が全て無効で電源電圧検出ADCが有効であれば電圧を応答します。(要確認)
			未対応：電源電圧ADCの範囲と単位を要確認。必要に応じて値を変換する必要がある。
	mode = MODE_GPIN(0x92)	 GPI data
*/
	byte ret=0xFF;

	if( ( data[3] == MODE_GPIN ) && ( data[17] != 0x00 ) ){			// data[3]:MODE_GPIN(92)  data[17]:mask(下位)
		if( xbee_from_acum( data ) > 0 ){							// 差出人をグローバル変数へ
			if( (data[17]&0xFE) != 0x00 ){							// DIO(port 1～7)がある時
				ret = (data[17] & data[20]);						// 20:DIOデータ(下位バイト) 17:マスク
			}else if( (data[18]&0x8E) != 0 ){						// ADCがあるとき
				if( data[16] == 0x00 && data[17] == 0x00 ){			// DIOが全てマスクされているとき
					ret = (data[19]<6) | (data[20]>2);				// 21:ADCデータ(上位)、22:下位
				}else{												// 
					ret = (data[21]<6) | (data[22]>2);				// 21:ADCデータ(上位)、22:下位
				}
			}
		}else{
			led_red( 1 );
			#ifdef ERRLOG
				strcopy( ERR_LOG , "ERR:xbee_gpi acum" );
				ERR_CODE = xbee_from_acum( data );
			#endif
		}
	}else{
		led_red( 1 );
		#ifdef ERRLOG
			strcopy( ERR_LOG , "ERR:xbee_gpi mode" );
			ERR_CODE = MODE_GPIN;
		#endif
	}
	#ifdef DEBUG_RX
		lcd_goto(LCD_ROW_2);
		lcd_putstr(" M:");				// MASK表示
		lcd_disp_hex( data[16] );
		lcd_disp_hex( data[17] );
		lcd_putstr(" D:");				// デジタルサンプル値
		lcd_disp_hex( data[19] );
		lcd_disp_hex( data[20] );
	#endif
	return(ret);
}

byte xbee_uart_acum( byte *data ){
/*
	mode =MODE_UART(0x90)	UART Receive
	mode =MODE_UAR2(0x91)	UART AO=0
*/
	#ifdef DEBUG_RX
	byte i;	// DEGUG用
	#endif
	byte len;
	byte ret=0;

	if( data[3] == 0x90 ){	// data[3]:データ種別=ZigBee Recieve Packet
		if( xbee_from_acum( data ) > 0 ){
			ret = data[15];						// 15:データ１文字 ※Digi仕様書P100記載誤り
			len = data[2]-0x0C;					// 12バイト減算
		}else{
			led_red( 1 );
			#ifdef ERRLOG
				strcopy( ERR_LOG , "ERR:xbee_uart from" );
				ERR_CODE = xbee_from_acum( data );
			#endif
		}
	}else if( data[3] == 0x91 ){	// data[3]:データ種別=ZigBee Explict Rx Indicator
		if( xbee_from_acum( data ) > 0 ){
			ret = data[21];						// 14:データ１文字
			len = data[2]-0x12;					// 18バイト減算
		}else{
			led_red( 1 );
			#ifdef ERRLOG
				strcopy( ERR_LOG , "ERR:xbee_uart2 from" );
				ERR_CODE = xbee_from_acum( data );
			#endif
		}
	}else{
		led_red( 1 );
		#ifdef ERRLOG
			strcopy( ERR_LOG , "ERR:xbee_uart mode" );
			ERR_CODE = data[3];		
		#endif
	}
	#ifdef DEBUG_RX
		lcd_goto(LCD_ROW_3);
		lcd_putstr("[");
		if( data[3]==0x90 && len>1 ) for(i=1; i< len ; i++) lcd_putch( data[15+i] );
		else if( data[3]==0x91 && len>1 ) for(i=1; i< len ; i++) lcd_putch( data[21+i] );
		else lcd_putch( ret );
		lcd_putstr( "]" );
		lcd_disp_hex( ret );
		lcd_putstr( " l=" );
		lcd_disp_hex( len );
		if( data[3]==0x91 ){
			lcd_putstr(" CI:");
			lcd_disp_hex( data[16] );
			lcd_disp_hex( data[17] );
			lcd_putstr(".");
			lcd_disp_hex( data[18] );
			lcd_disp_hex( data[19] );
		}
	#endif
	return(ret);
}

byte xbee_tx_rx(const char *at, byte *data, byte len){
/*
コマンド送信と受信がセットになったAPI(受信コマンドの簡単なチェックも実施)
	at:		ATコマンド(文字列)
	data[API_SIZE]:	入力データ／出力データ(共用)
	※本コマンドの処理中に受信した他のパケット(送信IDとATコマンド名で判定)は破棄する。
	(始めに受信キャッシュクリアしている)
	戻り値：エラー時 0x00
	
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/

	byte err,retry;
	byte r_dat = 10;	// AT=0、RAT=10、TX=未定	リモートATと通常ATの応答値dataの代入位置の差
	byte r_at = 1;		// AT=0、RAT=1				リモートの可否
	#ifdef CACHE_RES
		byte i;
	#endif
	
	sci_write_check();
	sci_clear();
	
	if( at[0] == 'A' && at[1] == 'T' ){
		r_dat = 0; r_at=0;
	} else if ( at[0] == 'R' && at[1] == 'A' && at[2] == 'T' ){
		r_dat = 10; r_at=1;
	}
	if( xbee_at_tx( at ,data ,len ) > 0){
		err = 12;							// 受信なしエラー
		for( retry = 10 ; ( retry > 0 && err != 0 ) ; retry-- ){
			wait_millisec( 10 + r_dat );	// 応答時間待ち AT 10～100ms / RAT 20～200ms
			if( xbee_at_rx( data ) > 0){
				if(		(
							( data[3] == MODE_RES  && r_at == 0 ) || ( data[3] == MODE_RESP && r_at == 1 )
						) && (
							data[4] == PACKET_ID
						)
					){
					 /*	ATコマンドが正しいかどうかの確認を削除(Ver 1.51)
					 	※MODE_RESPの条件を追加したので不要のはず。
					 && data[5+r_dat] == (byte)at[2+r_at] && data[6+r_dat] == (byte)at[3+r_at]
					 */
					if( data[7+r_dat] == 0x00 ){
						err=0;
					}else err = data[7+r_dat];	// ATのERRORコード (AT:data[7] RAT:data[17])
				}else{				// 受信したパケットIDまたはATコマンドが相違しているとき
					#ifdef CACHE_RES
						if( CACHE_COUNTER < CACHE_RES ){
							for( i=0 ; i < API_SIZE ; i++) CACHE_MEM[CACHE_COUNTER][i] = data[i];
							CACHE_COUNTER++;
							#ifdef DEBUG
								lcd_putstr("### CACHE_RES ### <- ");	// DEBUG
								lcd_disp_hex( CACHE_COUNTER );
								lcd_putch('\n');
							#endif
						}else err = 13;
					#else
						err = 13;		// キャッシュが無いと、どうしようもないのでエラー
					#endif
				}
			}
		}
	}else				err = 11;				// 送信失敗
	
	if( err ){
		wait_millisec( 1000 );		// 応答待ち状態で、次々にコマンドを送るとXBeeモジュールが非応答になる対策
		led_red( 1 );
		#ifdef ERRLOG
			ERR_CODE=err;
			switch(err){
				case 2:             // 01234567890123456789
					strcopy( ERR_LOG ,"ERR:tx_rx AT Command");
					break;
				case 3:
					strcopy( ERR_LOG ,"ERR:tx_rx AT Param. ");
					break;
				case 4:
					strcopy( ERR_LOG ,"ERR:tx_rx AT Commu. ");
					break;
				case 10:
					strcopy( ERR_LOG ,"ERR:tx_rx not AT CMD");
					break;
				case 11:
					strcopy( ERR_LOG ,"ERR:tx_rx TX Failed ");
					break;
				case 12:
					strcopy( ERR_LOG ,"ERR:tx_rx no Rx Res.");
					break;
				case 13:
					strcopy( ERR_LOG ,"ERR:tx_rx AT Pckt ID");
					break;
				case 14:
					strcopy( ERR_LOG ,"ERR:tx_rx Diff.Adrs.");
					break;
				default:
					strcopy( ERR_LOG ,"ERR:tx_rx AT unknown");
					break;
			}
			ERR_LOG[20] = ':'; 
			if( at[0] == 'A' ){
				ERR_LOG[21] = at[2];
				ERR_LOG[22] = at[3];
			}else{
				ERR_LOG[21] = at[3];
				ERR_LOG[22] = at[4];
			}
		#endif
	}
	#ifdef DEBUG
		if( err ) fprintf(stderr,"DEBUG: %s (err=%d)\n", ERR_LOG,err);
	#endif
	return( !err );
}

byte xbee_reset( void ){
	byte value[API_SIZE];
	value[0] = 0x00;
	byte i;
	byte ret;	// 戻り値 0:異常終了
	
	sci_write_check();
	sci_clear();						// シリアル異常をクリア
	wait_millisec(100);
	for( i=1 ; i< 4 ; i++){
		ret = xbee_tx_rx( "ATFR", value ,0 );
		if( ret > 0){ // ソフトウェアリセット
			i=4;
		}else{
			if( i == 3 ){
				lcd_cls();
				led_red( 1 );
				lcd_putstr( "EXIT:CANNOT RESET XBEE" );
				#ifdef H3694
					while(1);
				#elif ARDUINO
					while(1);
				#else
					exit(-1);
				#endif
			}
			wait_millisec(1000);
		}
	}
	wait_millisec(3000);				// リセット指示後3秒後に起動
	sci_clear();						// 再起動のメッセージをクリア
//	while( xbee_at_rx( value ) );		// パケットの破棄(念のため)
	if( ret > 0 ){
	for( i=1 ; i< 4 ; i++){
			ret = xbee_tx_rx("ATAI", value , 0 );
			if( ret > 0 ){
			i=4;
		}else{
			if( i == 3 ){
				lcd_cls();
				led_red( 1 );
				lcd_putstr( "ERR:CANOT REBOOT XB[" );
				lcd_disp_hex( value[7] );
				lcd_putstr( "] " );
				lcd_disp_hex( i );
				/*
				exit(-1);
				while(1);
				*/
			}
			wait_millisec(1000);
			}
		}
	}
	return( ret );
}

/***********************************************************************
XBee用 UART出力API
byte xbee_putch( const char c );
byte xbee_putstr( const char *s );
void xbee_disp_hex( const unsigned char i );
void xbee_disp_1( const unsigned int x );
void xbee_disp_2( unsigned int x );
void xbee_disp_3(unsigned int x);
void xbee_disp_5(unsigned int x);
void xbee_log( const byte level, const char *err , const byte x );
***********************************************************************/

byte xbee_putch( const char c ){
	byte data[2];
	byte len;
	data[0] = (byte)c;
	if( xbee_at_tx( "TX", data , 1) == 0 ) len=0;
	return( len );
}

byte xbee_putstr( const char *s ){
/*
	文字を送信する
	入力：char *s
	出力：送信データ長を応答。０の場合は異常
*/	
	byte data[API_TXSIZE];
	byte i;

	for(i=0; (i< API_TXSIZE) && (s[i] != 0x00) ; i++){
		data[i] = (byte)s[i];
	}
	data[i] = 0x00;
	if( xbee_at_tx( "TX", data , i) == 0) i=0;
	return( i );
}

void xbee_disp_hex( const byte i ){
	byte data[3];
    data[0] = i&0xF0;
    data[0] = data[0]>>4;
    data[0] += '0';
    if (data[0]>'9') data[0] += 7;
    data[1]=(i&0x0F)+'0';
    if (data[1]>'9') data[1]+=7;
	xbee_at_tx( "TX", data , 2);
}

void xbee_disp_1( const unsigned int x ){
	if 		(x<10)	xbee_putch((char)(x+0x30));
	else if (x<16)	xbee_putch((char)(x-10+'A'));
	else 			xbee_putch('X');
}

void xbee_disp_2( unsigned int x ){
	char s[3];
	unsigned int y;
	if (x<100){
		y=x/10; s[0]=(char)(y+0x30); x-=(y*10);
		s[1]=(char)(x+0x30);
		s[2]='\0';
		if( s[0]=='0' ){
			s[0]=' ';
		}
		xbee_putstr( s );
	}else xbee_putstr("XX");
}

void xbee_disp_3(unsigned int x){
	char s[4];
	unsigned int y;
	if (x<1000){
		y=x/100; s[0]=(char)(y+0x30); x-=(y*100);
		y=x/10;  s[1]=(char)(y+0x30); x-= (y*10);
		s[2]=(char)(x+0x30);
		s[3]='\0';
		if( s[0]=='0' ){
			s[0]=' ';
			if( s[1]=='0' ){
				s[1]=' ';
			}
		}
		xbee_putstr( s );
	}else xbee_putstr("XXX");
}

void xbee_disp_5(unsigned int x){
	char s[6];
	unsigned int y;
	if (x<=65535){
		y=x/10000; s[0]=(char)(y+0x30); x-=(y*10000);
		y=x/1000;  s[1]=(char)(y+0x30); x-= (y*1000);
		y=x/100;   s[2]=(char)(y+0x30); x-=  (y*100);
		y=x/10;    s[3]=(char)(y+0x30); x-=   (y*10);
		s[4]=(char)(x+0x30);
		s[5]='\0';
		if( s[0]=='0' ){
			s[0]=' ';
			if( s[1]=='0' ){
				s[1]=' ';
				if( s[2]=='0' ){
					s[2]=' ';
					if( s[3]=='0' ){
						s[3]=' ';
					}
				}
			}
		}
		xbee_putstr( s );
	}else xbee_putstr("XXXXX");
}

void xbee_log(const byte level, const char *err, const byte x ){
/*
	エラーログ用レベルガイド
		LEVEL 5	ERROR	致命的なエラー、バグ発生
		LEVEL 4	ERR		通信エラー等のうち不具合動作を伴う懸念のあるもの。500ms待ち挿入
		LEVEL 3	CAUTION	通信エラー、使い方の問題など
		LEVEL 2	未定義
		LEVEL 1	LOG		各関数の動作確認用
*/
	#ifdef ERRLOG
		#ifdef DEBUG
			if( level >= 1 ){
		#else
			if( level >= 3 ){
		#endif
			lcd_goto(LCD_ROW_4);
			lcd_putch('[');
			lcd_disp_hex( TIMER_SEC );
			lcd_putch(':');
			lcd_disp_hex( timera() );
			lcd_putch(']');
			lcd_putstr( err );
			lcd_putch('(');
			lcd_disp_hex( x );
			lcd_putch(')');
			lcd_putch( 0x0D );				// CR(\r)
			lcd_putch( 0x0A );				// LF(\n)
			#ifndef ARDUINO
			#ifndef H3694
				fprintf(stderr,"[%02X:%02X]%s(%02X)\n",TIMER_SEC,timera(),err,x);
			#endif
			#endif
		}
	#endif
	if( level > 3 ) wait_millisec( 500 );	// LEVEL 4以上に対して待ち時間を設定
}

/***********************************************************************
アプリ向け提供関数
XBee用 各種制御 入出力定義を変更した場合は履歴に記載します
***********************************************************************/

byte xbee_myaddress( byte *address ){
/*
自分自身のIEEEアドレスを取得する
	byte *address : IEEEアドレスを代入する
	戻り値＝１で正常終了。０は異常
*/
	byte data[API_SIZE];
	byte i=0;
	byte ret=0;
	
	data[0]=0x00;
	/* ショートアドレスの取得はしないことにする。(Coordinatorは常に00)
	if( xbee_tx_rx( "ATMY",data,0) ){
		for(i=0;i<2;i++){
			SADR_MY[i]=data[8+i];
		}
	}
	*/
	data[0]=0x00;
	if( xbee_tx_rx( "ATSH",data,0) ){
		for(i=0;i<4;i++){
			address[i]=data[8+i];
		}
		data[0]=0x00;
		if( xbee_tx_rx( "ATSL",data,0) ){
			for(i=0;i<4;i++){
				address[4+i]=data[8+i];
			}
			ret=1;
		}
	}
	if( ret==0 ) xbee_log( 5, "ERROR: at at_my" , 0 );
	xbee_log( 1, "done:xbee_myaddress" , ret );
	return( ret );
}

void xbee_address(const byte *address){
/*
		<li>送信用の宛先アドレス設定用の関数
		<li>入力：byte *address = 宛先(子機)アドレス
*/
	byte i;
	for(i=0; i< 8 ;i++ ) ADR_DIST[i] = address[i];
	#ifdef DEBUG
	lcd_cls(); lcd_goto(LCD_ROW_1); lcd_putstr("DIST=");
	for(i=4;i<8;i++){ lcd_disp_hex( ADR_DIST[i] ); lcd_putstr(" "); }
	#endif
	xbee_log( 1, "done:xbee_address" , address[7] );
}

void xbee_from(byte *address){
/*
	受信した時の送信元アドレスの読み込み。「構造体XBEE_RESULT変数.FROM」でも読み込み可能
	出力：byte *address IEEEアドレス
*/
	byte i;
	for(i=0; i< 8 ;i++ ){
		address[i] = ADR_FROM[i];
	}
	xbee_log( 1, "done:xbee_from" , address[7] );
}

byte xbee_rat(const byte *address, const char *in){
/*
	リモートATコマンドを送信するユーザ提供関数
	入力：byte *address = 宛先(子機)アドレス 
	　　　char *in = 入力するATコマンド 例： ATDL0000FFFF 最大文字数は XB_AT_SIZE-1
	出力：ATコマンドの結果 STATUS_OK / STATUS_ERR / STATUS_ERR_AT / STATUS_ERR_PARM / STATUS_ERR_AIR
	　　　0xFFで送信失敗もしくはデータ異常
	　　　別関数のxbee_ratnjとはエラー時の戻り値が異なる。
	　　　ratnjは正常が複数あるので異常時がNULL、atはエラーが複数あるので正常時がNULL
	　　　別関数atnjよりも先に定義する。関数非宣言でのコンパイルに対応するため
*/
	char at[6];
	byte data[API_SIZE];
	byte i, j, len, val;
	byte ret = 0xFF;
	byte com_len =0;
	byte null_adr[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
	
	if( in[0]=='A' && in[1]=='T' ){
		if( bytecmp(null_adr,address,8) == 0 ){
			// xbee_atから呼ばれた場合 ATxx_
			com_len = 4;						// 入力ATコマンド長 ATxx 4
			at[0]='A'; at[1]='T';
			if( in[2] == '\0' ){
				at[2]='D'; at[3]='D';
			}else{
				at[2]=in[2]; at[3]=in[3];
			}
			at[4]='\0';
		}else{
			// リモートat(xbee_rat)指定で呼び出された場合 RATxx_
			com_len = 4;						// 入力ATコマンド長 ATxx 4
			at[0]='R'; at[1]='A'; at[2]='T';
			// アプリ呼び出しにつき、ATの後に何もない場合が想定される。その時はATDDとみなす
			if( in[2] == '\0' ){
				at[3]='D'; at[4]='D';
			}else{
				at[3]=in[2]; at[4]=in[3];
			}
			at[5]='\0';
			xbee_address(address);
		}
	}else if( in[0]=='R' && in[1]=='A' && in[2]=='T' ){
		com_len = 5;							// 入力ATコマンド長 RATxx 5
		at[0]='R'; at[1]='A'; at[2]='T';
		at[3]=in[3]; at[4]=in[4];
		at[5]='\0';
		xbee_address(address);
	}else if( in[0]=='T' && in[1]=='X' ){
		com_len = 2;							// 入力ATコマンド長 TX 2
		at[0]='T'; at[1]='X'; 
		at[2]='\0';
		xbee_address(address);
	}
	if( com_len > 0 ){
		/* ATコマンドに続く16進数の引数入力 */
		for( len = 0 ; len < API_SIZE ; len++ ){
			j = (byte)in[len * 2 + com_len];
			i = (byte)in[len * 2 + com_len + 1];
			if( j == (byte)'\0' || i == (byte)'\0' )break;
			// 16進数の文字を数字にしてdataに代入。1桁は考慮。奇数桁は考慮せずに処理。
			if( (j >= (byte)'0' && j <= (byte)'9') || (j >= (byte)'A' && j <= (byte)'F') ){
				if( j > '9' ) data[len] = j - (byte)'A' + 10;
				else data[len] = j - (byte)'0';
				if( (i >= (byte)'0' && i <= (byte)'9') || (i >= (byte)'A' && i <= (byte)'F') ){
					if( i > '9' ) val = i - (byte)'A' + 10;
					else val = i - (byte)'0';
					data[len] *= 16;
					data[len] += val;
				}
			}else break;
		}
		// test
		// printf("xbee_tx_rx %s len=%d\n",at,len);
		xbee_log( 1, "started:xbee_at" , in[0] );
		if( xbee_tx_rx( at, data ,len ) > 0 ){
			xbee_log( 1, "done:at" , in[0] );
			if( data[3] == MODE_RES ){
				ret = data[7];
			}else if( data[3] == MODE_RESP ){
				ret = data[17];
			}else{
				ret = 0xFF;
			}
		}
	}
	return( ret );
}

byte xbee_at(const char *in){
/*
	ローカルATコマンドを送信するユーザ提供関数
	入力：char *in = 入力するATコマンド 例： ATDL0000FFFF 最大文字数は XB_AT_SIZE-1
	出力：ATコマンドの結果 STATUS_OK / STATUS_ERR / STATUS_ERR_AT / STATUS_ERR_PARM / STATUS_ERR_AIR
	　　　0xFFで送信失敗もしくはデータ異常
	　　　別関数xbee_atnjとエラー時の戻り値が異なる。
	　　　atnjは正常が複数あるので異常時がNULL、atはエラーが複数あるので正常時がNULL
*/
	byte address[] =	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
	return( xbee_rat( address, in) );
}

byte xbee_atai(void){
/*
	XBeeモジュールの状態を確認するコマンド　AT Association Indication
	出力：
		0x00 - Successfully formed or joined a network. (Coordinators form a network, routers
				and end devices join a network.)
				※Routerに対して実行すると、01が返ってくる。仕様書には記載なし。
		0x21 - Scan found no PANs
		0x22 - Scan found no valid PANs based on current SC and ID settings
		0x23 - Valid Coordinator or Routers found, but they are not allowing joining (NJ expired)
		0x24 - No joinable beacons were found
		0x25 - Unexpected state, node should not be attempting to join at this time
		0x27 - Node Joining attempt failed (typically due to incompatible security settings)
		0x2A - Coordinator Start attempt failed‘
		0x2B - Checking for an existing coordinator
		0x2C - Attempt to leave the network failed
		0xAB - Attempted to join a device that did not respond.
		0xAC - Secure join error - network security key received unsecured
		0xAD - Secure join error - network security key not received
		0xAF - Secure join error - joining device does not have the right preconfigured link key
		0xFF - Scanning for a ZigBee network (routers and end devices)
	
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
　　　本コマンドをXBeeに送ると、XBeeからの応答用キャッシュがクリアされる場合があります。
　　　例えば、xbee_forceなどの応答を後から得るコマンドを実行後に本コマンドを実行すると
　　　xbee_rx_callで応答が受け取れなくなる場合があります。
　　　このような場合、xbee_ataiを実行してからxbee_forceを実行するような手順にしてください。
*/
	byte data[API_SIZE];
	byte ret=0xFF;

	// xbee_log( 1, "started:xbee_atai" , 0x00 );
	if( xbee_tx_rx( "ATAI", data ,0 ) > 0 ){
		wait_millisec(100);
		if( data[7] == 0x00 ){
			ret = data[8];
		}
	}
	xbee_log( 1, "done:xbee_atai" , ret );
	return( ret );
}

unsigned short xbee_atop(byte *pan_id){
/*
	PAN Idを求めるコマンド(書き込めないD
	出力：byte pan_id[8] PAN_ID 64bit (8bytes)
	　　　unsigned short 戻り値 = PAN_ID 16bit
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte data[API_SIZE];
	byte i;
	unsigned short pan_id_s;

	for( i=0 ; i<8 ; i++ ) pan_id[i] = 0x00;
	xbee_log( 1, "started:xbee_atop" , 0x00 );
	if( xbee_tx_rx( "ATOP", data ,0 ) > 0 ){
		wait_millisec(100);
		if( data[7] == 0x00 ){
			for( i=0 ; i<8 ; i++ ) pan_id[i] = data[8+i];
		}
		xbee_tx_rx( "ATOI", data ,0 );
		if( data[7] == 0x00 ){
			pan_id_s = (unsigned short)data[8] * 16 + (unsigned short)data[9];
		}
		wait_millisec(100);
	}
	xbee_log( 1, "done:xbee_atop" , 0x00 );
	return( pan_id_s );
}

byte xbee_atnj(const byte timeout){
/*
	制限時間timeoutで設定した間にネットワークに参加したデバイスを通信相手に設定する関数 
	AT Node Join Time
	入力：timeout = 時間(1～254秒)、0XFFの場合は参加待ちを実行しない。 
	出力：byte 戻り値 = 0x00失敗、成功時はMODE_IDNT(0x95)が代入される 
	　　　xbee_atとエラー時の戻り値が異なる。
	　　　atはエラーが複数あるので正常時がNULL、atnjは正常が複数あるので異常時がNULL
	　　　また、atnjはfopenと似た記述になるので、特殊な応答でもない(と思う)
	
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte data[API_SIZE];
	byte i=0, ret, timer;

	data[0]=timeout;
	xbee_log( 1, "started:xbee_atnj" , timeout );
	ret = xbee_tx_rx( "ATNJ", data ,1 );
	if( ret > 0 ){
		wait_millisec(100);
		if( timeout == 0xFF ){
			/*常に参加待ち受けするテスト専用(非実用)*/
			ret=0xFF;
			xbee_log( 3, "CAUTION:ATNJ=" , timeout );
			wait_millisec(1000);			// NJ値の書込み時間待ち
		}else{
			if( timeout != 0x00 ){
			/*参加待ち受けの開始*/
			timer = TIMER_SEC + timeout + 0x01 ;
			ret = 0x00;
			while( timer != TIMER_SEC && ret != MODE_IDNT){	// MODE_IDNT(0x95)はネットワーク参加
				if( (timera()>>6)&0x01 ){
					led_green( 0 );	// LEDのトグル1秒に4回
				} else {
					led_green( 1 );
				}
				if( xbee_at_rx( data ) > 0x00 ){	// データの受信(戻り値は受信種別mode値)
					ret = xbee_from_acum(data);
					if( ret == MODE_IDNT ){		// 受信モードがMODE_IDNT(0x95) Node Identifyの場合
						xbee_log( 1, "Found device " , ret );
						for(i=0;i<8;i++) ADR_DIST[i]=ADR_FROM[i];			// 宛先を発見デバイスに設定
						sci_write_check();
						sci_clear();
						}else ret=0x00;
				}
			}
				if( ret == 0x00 ) xbee_log( 1, "no new device" , ret );
			}
			/*参加モード解除(5秒後)設定*/
			data[0]=0x05;
			xbee_tx_rx( "ATNJ", data ,1 );
			xbee_log( 1, "done:atnj=0" , 0x00 );
		}
	}else xbee_log( 5, "ERROR:xbee_atnj" , ret );
	xbee_log( 1, "done:xbee_atnj" , ret );
	return( ret );
}

byte xbee_ratnj(const byte *address, const byte timeout){
/*
	前記xbee_atnjをリモート先(子機)に対して設定する関数 
	入力：byte *address = 宛先(子機)アドレス 
	入力：timeout = 0でジョイン拒否、1～254で待ち秒数、255で常時ジョイン許可 
	出力：byte 戻り値 = 0x00失敗、0xFF成功 
	
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte data[API_SIZE];
	byte ret=0x00;

	xbee_address(address);							// 宛先のアドレスを設定
	data[0]=timeout;
	if( xbee_tx_rx( "RATNJ", data ,1 ) > 0 ){
		xbee_log( 1, "done:ratnj" , xbee_tx_rx( "ATAC", data ,0 ) );
		ret=0xFF;
	}
	xbee_log( 1, "done:xbee_atrnj" , ret );
	return( ret );
}

byte xbee_ping(const byte *address ){
/*
入力：IEEEアドレスaddress
出力：					0xFF 		エラー
		DEV_TYPE_XBEE	0x00		// XBeeモジュール
		DEV_TYPE_RS232	0x05		// RS-232Cアダプタ
		DEV_TYPE_SENS	0x07		// Sensor (1wire専用)
		DEV_TYPE_PLUG	0x0F		// SmartPlug
	
	byte 戻り値 = 0xFF失敗、成功時は0x00などのデバイス名(ATDD)の下2桁 
	
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte ret=0xFF;		// デバイス名
	byte data[API_SIZE];

	xbee_address(address);							// 宛先のアドレスを設定
	if( xbee_tx_rx( "RATDD", data ,0 ) > 0 ){		// デバイス名を取得
		if( data[18]==0x00 && data[19]==0x03 && data[20]==0x00 ){	// XBeeデバイス
			ret=data[21];							// デバイス名をddに代入
		}
	}
	xbee_log( 1, "done:xbee_ping" , ret );
	return( ret );
}

int xbee_batt(const byte *address ){
/*
電池電圧の確認
入力：IEEEアドレスaddress
出力：約2100～3600[mV]、-1=エラー 
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	int ret=-1;
	byte data[API_SIZE];

	xbee_address(address);							// 宛先のアドレスを設定
	if( xbee_tx_rx( "RAT%V", data ,0 ) > 0 ){		// 電池電圧を取得
		ret = (int)(((float)data[18] * 256. + (float)data[19] ) * (1200. / 1024.));
	}
	xbee_log( 1, "done:xbee_batt" , (byte)(ret/100) );
	return( ret );
}

byte xbee_batt_force(const byte *address ){
/*
電池電圧の確認
入力：IEEEアドレスaddress
xbee_batt_forceで測定指示を出して、xbee_rx_callで受け取ります。
XBEE_RESULT.MODEに「MODE_BATT(0xE1)」が設定されるので他のリモートＡＴレスポンスと区別することが出来ます。
電圧値はXBEE_RESULT.ADC[0]に約2100～3600[mV]の範囲で応答します。
*/
	byte data[XB_AT_SIZE];
	byte ret = 0x00;
	
	xbee_address( address );							// 送信先を指定
	ret = xbee_at_tx("RAT%V", data , 0);				// ATISを送信
	xbee_log( 1, "done:xbee_batt_force" , ret );
	return ( ret );
}

#ifdef ARDUINO
byte xbee_gpio_config(const byte *address, const byte port, byte type ){
#else
byte xbee_gpio_config(const byte *address, const byte port, const enum xbee_port_type type ){
#endif
/*
入力：IEEEアドレスaddress、GPIOポート番号port、設定値type
		enum xbee_port_type{ DISABLE=0, VENDER=1, AIN=2, DIN=3, DOUT_L=4, DOUT_H=5 };

	port:	port指定	IO名	ピン番号	共用		USB評価ボード(XBIB-U-Dev)
			port= 0		DIO0	XBee_pin 20 (Cms)	    SW Commision コミッションボタン
			port= 1		DIO1	XBee_pin 19 (AD1)	    SW2 汎用入力用(DIN or AIN)
			port= 2		DIO2	XBee_pin 18 (AD2)	    SW3 汎用入力用(DIN or AIN)
			port= 3		DIO3	XBee_pin 17 (AD3)	    SW4 汎用入力用(DIN or AIN)
			port= 4		DIO4	XBee_pin 16 (RTS)	    LED3 汎用出力用
			port= 5		DIO5	XBee_pin 15 (Ass)	    ASSOSIATE indication
			port=10		DIO10	XBee_pin  6 (RSSI)	    RSSI indication (PWM)
			port=11		DIO11	XBee_pin  7			    LED2 汎用出力用
			port=12		DIO12	XBee_pin  4			    LED1 汎用出力用

注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte i=0;
	byte ret=0xFF;
	byte data[API_SIZE];
	byte adr_my[8];
	char at[] = "RATD0" ;	// ATコマンド
	byte dd=0xFF;			// デバイス名

	switch( type ){
		case DISABLE:
			if( port >= 1 ) {
				at[4] = '0' + port;
				ret=0;
			}
			break;
		case VENDER:
			if( port == 0 || port == 5 || port == 10) ret=0;
			break;
		case AIN:
			if( port >= 1 && port <= 4 ){
				at[4] = '0' + port;
				ret=0;
			}else if( port == 0xFF ){
				ret=0;
			}
			break;
		case DIN:
		case DOUT_L:
		case DOUT_H:
			if( port >= 1 && port <= 5 ){
				at[4] = '0' + port;
				ret=0;
			}else if( port >= 10 && port <= 12 ){
				at[3] = 'P';
				at[4] = '0' + (port - 10);
				ret=0;
			}else if( port == 0xFF ){
				ret=0;
			}
			break;
		default:
			break;
	}
	if( ret==0 ){
		if( xbee_myaddress(adr_my) ){								// 自分のアドレスを取得
			#ifdef DEBUG
				printf("adr_my =");
				for( i=0 ; i<8 ; i++) printf("%02x ",adr_my[i]);		
				printf("\n");
			#endif
			xbee_address(address);								// 宛先のアドレスを設定
			for( i=0;i<4;i++) data[i]=adr_my[i];				// 上位４バイトをdataに代入
			if( xbee_tx_rx( "RATDH", data ,4 ) > 0 ){				// 上位４バイトを設定
				for( i=0;i<4;i++) data[i]=adr_my[i+4];			// 下位４バイトをdataに代入
				if( xbee_tx_rx( "RATDL", data ,4 ) > 0 ){			// 下位４バイトを設定
					dd = 0x95;									// 設定が成功したフラグ代わりに戻り値に95を代入
					if( xbee_tx_rx( "RATDD", data ,0 ) > 0 ){		// デバイス名を取得
						dd=data[21];							// デバイス名をddに代入
						if( data[18]==0x00 && data[19]==0x03 && data[20]==0x00 ){	// XBeeデバイス
							if( dd==0x00 || ( dd == 0x0F && port == 0x03 ) ){
																// デフォルトXBeeモジュールorSmartPlug
								if( port == 0xFF){
									data[0]=(byte)type;
									xbee_tx_rx( "RATD1", data ,1 );
									data[0]=(byte)type;
									xbee_tx_rx( "RATD2", data ,1 );
									data[0]=(byte)type;
									xbee_tx_rx( "RATD3", data ,1 );
									xbee_log( 1, "done:congig" , 3 );
									if( type == DIN ){
										data[0]=0x00;
										data[1]=0x0E;			// ポート1～3の↓
										xbee_tx_rx( "RATIC", data ,2 );	// 入力値が変化したら通知する
									}
								}else{
									data[0]=(byte)type;
									xbee_tx_rx( at , data ,1 );
								}
								xbee_log( 1, "done:port set" , dd );
							}else{
								xbee_log( 3, "CAUTION:not ZB module" , dd );
							}
						}
					}
				}
			}else xbee_log( 4, "ERR:tx_rx RATDH at gpio_conf" , 1 );
		}else xbee_log( 4, "ERR:at_my at gpio_conf" , 1 );
	}
	xbee_log( 1, "done:xbee_gpio_config" , dd );
	return( dd );
}

byte xbee_gpio_init(const byte *address){
/*
子機XBeeデバイス(リモート先)のGPIOを入力に設定する関数
リモート端末の宛先を本機アドレスに設定(リモート側のボタンで親機に送信するために)
入力：なし
出力：デバイス名(ATDDの下2桁)、FFでエラー
注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte dd;

	dd = xbee_gpio_config( address, 0xFF, DIN );
	if( dd != 0x00 &&		// XBee単品モジュール(0x00)ではない
		dd != 0x0F ){		// SmartPlug(0x0F)でもない
		xbee_log( 4, "ERR:gpio_init DD" , dd );
	}else{
		xbee_log( 1, "done:gpio_init" , 0 );
	}
	return( dd );
}

byte xbee_gpo(const byte *address, const byte port,const byte out){
/*
子機XBeeデバイス(リモート先)のGPIOへ出力する関数
portは1～4と11～12が指定できるが、port 1～3を入力で使用する場合は4,11,12。
	port:	port指定	IO名	ピン番号			USB評価ボード(XBIB-U-Dev)
			port= 0		DIO0	XBee_pin 20 (Cms)	    SW1 Commision
			port= 1		DIO1	XBee_pin 19 (AD1)	    SW2
			port= 2		DIO2	XBee_pin 18 (AD2)	    SW3
			port= 3		DIO3	XBee_pin 17 (AD3)	    SW4
			port= 4		DIO4	XBee_pin 16 (RTS)	    LED3	※port4 がLED3
			port=11		DIO11	XBee_pin  7			    LED2	※port11がLED2
			port=12		DIO12	XBee_pin  4			    LED1	※port12がLED1
	out:	out=0 L出力		out=1 H出力
*/
	char at[6];
	byte data[API_SIZE];
//	byte i=0;
	byte ret=0;
	
	xbee_address(address);									// 宛先のアドレスを設定
	at[0]='S'; at[1]='A'; at[2]='T'; at[3]=0; at[5]='\0'; 
	// at[0]='R'; 	// RAT(応答待ち)の場合にコメントを外す
	if( port >= 1 && port <= 4 ){
		at[3] = 'D';
		at[4] = '0' + port;
	}else if( port >= 11 && port <= 12 ){
		at[3] = 'P';
		at[4] = '0' + (port - 10);
	}
	if( at[3] ){
		data[0]=0x05;					// output = H
		if( out == 0 ) data[0]=0x04;	// output = L
		data[1]=0x00;
		ret = xbee_at_tx( at, data ,1 );
		// ret = xbee_tx_rx( at, data ,1 );	// RAT(応答待ち)の場合にコメントを外す
	}
	#ifdef DEBUG
		lcd_goto(LCD_ROW_3);
		if( ret==0 ){
			lcd_putstr("GPO ERR:");
		}else{
			lcd_putstr("GPO OK:");
		}
		lcd_disp_hex( data[17] );
	#endif
	xbee_log( 1, "done:xbee_gpo" , ret );
	return(ret);
}

#ifdef EASY_GPI
byte xbee_gpi(const byte *address, const byte port){
/*	リモート先(ADR_FROMに入力)のGPIOの入力値を応答するAPI

★注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
本コマンドでは無くxbee_forceとxbee_rx_callの組み合わせでの利用を推奨します。

portは1～4と11～12と0xFFが指定できる。
port=0xFFでポート0～7をHEXで応答する。
AINはxbee_adcを使用する。
	port:	port指定	IO名	ピン番号			USB評価ボード(XBIB-U-Dev)
			port= 1		DIO1	XBee_pin 19 (AD1)	     SW2
			port= 2		DIO2	XBee_pin 18 (AD2)	     SW3
			port= 3		DIO3	XBee_pin 17 (AD3)	     SW4
	out: 指定ポートの状態 0または1、エラー時は0xFF

設計情報
	リターン信号例
	00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
	7E 00 15 97 01 00 13 A2 00 -- -- -- -- -- -- 49 53 00 01 18 1E 00 00 0E 8A
	  | len |mo|FI|送信元IEEEアドレス     |Short|AT(IS)  |01|MASK |AD|DATA |CS|
	  |     |de|
	  |     |__|__________________ MODE_RESP(0x97)= ATIS応答
	  |_____|_____________________ Data Length
*/
	byte data[API_SIZE];
	byte ret=0xFF;

	xbee_address(address);								// 宛先のアドレスを設定
	if( xbee_tx_rx("RATIS", data , 0) > 0 ){
		if( data[3]==MODE_RESP ){						// d[3] flame ID = 97(RAT応答)
			if( port == 0xFF) ret = (data[23] & data[20]);
			else{
				if( (port >= 1) && (port <= 4) ){
					if( ((data[20]>>port)&0x01) == 0x00 ){	// MASK_L(20)の該当ビットが否の時
						data[0]=0x03; // リモート端末のポート1～3をデジタル入力(0x03)に設定
						if( port ==1 ) xbee_tx_rx( "RATD1", data ,1 );
						if( port ==2 ) xbee_tx_rx( "RATD2", data ,1 );
						if( port ==3 ) xbee_tx_rx( "RATD3", data ,1 );
						if( port ==4 ) xbee_tx_rx( "RATD4", data ,1 );
						wait_millisec(1000);
						xbee_tx_rx("RATIS", data , 0);	// 再度ISを実行
					}
					if( data[3]==MODE_RESP ) ret= ((data[23] >> port ) & 0x01);	// 取得データDATA_L(23)を戻り値に
				} else if( (port >= 11) && (port <= 12) ){
					if( ((data[19]>>(port-8))&0x01) == 0x00 ){	// MASK_H(19)の該当ビットが否の時
						data[0]=0x03; // リモート端末のポート1～3をデジタル入力(0x03)に設定
						if( port ==11 ) xbee_tx_rx( "RATP1", data ,1 );
						if( port ==12 ) xbee_tx_rx( "RATP2", data ,1 );
						wait_millisec(100);
						xbee_tx_rx("RATIS", data , 0);
					}
					if( data[3]==MODE_RESP ) ret= ((data[22] >> (port-8))& 0x01);	// 取得データDATA_H(22)を戻り値に
				}
			}
		}
	}
	#ifdef DEBUG
		lcd_goto(LCD_ROW_3);
		lcd_putstr("port"); lcd_disp_hex( port ); lcd_putstr("="); lcd_disp_hex( ret );	// 戻り値
		lcd_goto(LCD_ROW_4);
		lcd_putstr(" f:"); lcd_disp_hex( data[3]); 
		lcd_putstr(" M:"); lcd_disp_hex( data[19] ); lcd_disp_hex( data[20] );	// MASK表示
		lcd_putstr(" D:"); lcd_disp_hex( data[22] ); lcd_disp_hex( data[23] );	// デジタルサンプル値
	#endif
	xbee_log( 1, "done:xbee_gpi" , ret );
	return( ret );
}
#endif // EASY_GPI

#ifdef EASY_ADC
unsigned int xbee_adc(const byte *address, const byte port){
/*	リモート先(addressに入力)のADCの入力値を応答するAPI
portは1～3が指定できる。指定したportがADC入力でない場合はADC入力に切り替える。
	port:	port指定	IO名	ピン番号			USB評価ボード(XBIB-U-Dev)
			port= 1		DIO1	XBee_pin 19 (AD1)	    SW2
			port= 2		DIO2	XBee_pin 18 (AD2)	    SW3
			port= 3		DIO3	XBee_pin 17 (AD3)	    SW4
	out:	ADC値
	
設計情報
	リターン信号例
	00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26
	7E 00 17 97 01 00 13 A2 00 -- -- -- -- -- -- 49 53 00 01 18 16 08 18 06 00 00 7A
	  | len |mo|FI|送信元IEEEアドレス     |Short|AT(IS)  |01|GPIO |AD|GPIO |ADC  |CS
	  |     |de|  |                       |Adrss|        |01|MASK |MS|DATA |DATA |
	  |     |  |  |                                               |  |
	  |     |  |                          ADC MASK________________|__|
	  |     |__|__________________ MODE_RESP(0x97)= ATIS応答
	  |_____|_____________________ Data Length

注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
*/
	byte data[API_SIZE];
	byte ports=1;
	unsigned int ret=0xFFFF;

	xbee_address(address);								// 宛先のアドレスを設定
	if( xbee_tx_rx("RATIS", data , 0) > 0 ){
		if( data[3]==MODE_RESP ){						// d[3] flame ID = 97(MODE_RESP)
			if( (port >= 1) && (port <= 3) ){
				if( ((data[21]>>port ) & 0x01) == 0x00 ){	// MASKの該当ビットが否の時
					data[0]=0x02; // リモート端末のポート1～3をADC入力(0x02)に設定
					if( port == 1 ) xbee_tx_rx( "RATD1", data ,1 );
					if( port == 2 ) xbee_tx_rx( "RATD2", data ,1 );
					if( port == 3 ) xbee_tx_rx( "RATD3", data ,1 );
					wait_millisec(1000);
					xbee_tx_rx("RATIS", data , 0);	// 再度ISを実行
				}
				if( (port == 2) && ((data[21]>>1)&0x01) ) ports =2;		// port2指定でport1がADCならデータは2個
				else if ( port == 3 ){
					if( (data[21]>>2)&(data[21]>>1)&0x01 ) ports =3; // port3指定でport1と2がADCならデータは3個
					else if( ((data[21]>>2)|(data[21]>>1))&0x01 ) ports =2; // port3指定でport1か2の片方がADCならデータは2個
				}
				if( data[3]==MODE_RESP ) ret= (unsigned int)data[22+ports*2]*256 + (unsigned int)data[23+ports*2];
																		// 取得データを戻り値に
			}
		}
	}
	#ifdef DEBUG
		lcd_goto(LCD_ROW_4); lcd_putstr("ADC "); lcd_disp_hex( port ); lcd_putstr("=");
		lcd_disp_hex( data[21] ); lcd_putstr(" "); lcd_disp_5( ret );
	#endif
	xbee_log( 1, "done:xbee_adc" , ret );
	return( ret );
}
#endif // EASY_ADC

byte xbee_force(const byte *address ){
/*
	GPIOやXBee Sensor(XBee Sensor /L/T または /L/T/H) へ測定指示(ATIS)を送るコマンド
	本xbee_forceで測定指示を出して、xbee_rx_callで受け取ることを推奨します。
	XBee Sensor はxbee_sensor_resultでセンサー値を計算できます。
	入力：送信アドレス
	出力：送信結果（送信したAPIサービス長。送信しなかった場合は0）
*/
	byte ret = 0x00;
	byte null_data [] = { 0x00 };
	
	xbee_address( address );							// 送信先を指定
	ret = xbee_at_tx("RATIS", null_data , 0);				// ATISを送信
	xbee_log( 1, "done:xbee_force" , ret );
	return ( ret );
}

#ifdef ARDUINO
	float xbee_sensor_result( XBEE_RESULT *xbee_result, const byte type){
#else
	float xbee_sensor_result( XBEE_RESULT *xbee_result, const enum xbee_sensor_type type ){
#endif
/*
コールバック関数xbee_rx_callで取得したxbee_sensorデータを値に変換するAPI(非通信) 
call_result情報から変換
LIGHTはXBee Sensor用
WATTはXBee Smart Plug用

	入力：enum xbee_sensor_type {LIGHT,TEMP,HUMIDITY,WATT};	// センサタイプの型
	出力：float センサ読み取り値

	XBee Sensor(XBee Sensor /L/T または /L/T/H) ※ 1-wire Sensor Adapterではない

	設計情報
		リターン信号例
		00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
		7E 00 1B 97 01 00 13 A2 00 -- -- -- -- -- -- 49 53 00 01 08 00 0E 08 00 03 E2 02 62 02 16 A1
		  | len |mo|FI|送信元IEEEアドレス     |Short|AT(IS)  |01|GPIO |AD|GPIO |ADC1 |ADC2 |ADC3 |CS
		  |     |de|  |                       |Adrss|        |01|MASK |MS|DATA |DATA |DATA |DATA |
		  |     |  |  |                                               |  |     |Light|Temp |Humidity
		  |     |  |                          ADC MASK________________|__|
		  |     |__|__________________ MODE_RESP(0x97)= ATIS応答          [手間！]この先はMASKによって
		  |_____|_____________________ Data Length                        データの無い部分は省略される
*/

	float ret = -1;
	
	switch(type){
		case LIGHT:
			ret = ((float)(xbee_result->ADCIN[1]))*1.17302;
													// (ADC1) /1023.0) * 1200
			break;
		case TEMP:
			ret = ((float)(xbee_result->ADCIN[2]))*0.117302-50.0;
													// (((ADC2/1023.0) * 1200) - 500.0)/ 10.0
			/*
			XBee ルータの温度測定結果は内部温度による上昇分が加算されます。
			Digi社によると約4℃の上昇があるので4℃を減算して使用することを推奨している。
			本ライブラリでは減算していませんが、実際の温度差を測定したところ
			平均7.12℃の差がありました。(27.2℃～28.0℃の環境下での平均誤差)
			*/
			break;
		case HUMIDITY:
			ret = ((float)(xbee_result->ADCIN[3]))*1.17302;
													// mVanalog = (ADC3/1023.0) * 1200
			ret = (((ret * 108.2 / 33.2) / 5000 - 0.16) / 0.0062);
													// hum = (((mVanalog * 108.2 / 33.2) / 5000 - 0.16) / 0.0062)
			break;
		case WATT:
			ret = ((float)(xbee_result->ADCIN[3]))*1.17302;
			ret = (ret * 156.0 / 47.0 - 520.0) / 180.0 * 70.71 ;
													// current = (mV*(156.0/47.0) - 520.0) /180.0 * .7071
			/*	電圧を測定していないのでワットへの変換は100Vを乗算している。*/
			/*	XBee Smart Plugは誘導負荷が考慮されないので測定値は参考値にしかならない。
				(モーターなどの力率の悪いものは測れない)
				The XBee Smart Plug uses a hall-effect current sensor IC to detect RMS current draw
				from the user controlled outlet. As there is no power factor correction for inductive loads,
				sensor accuracy is only specified for resistive loads. Current measurements can still be
				made on inductive loads that fall within the product load rating, but accuracy is not
				guaranteed.	*/
			if( ret < 0 ) ret = 0;
			break;
		default:
			break;
	}
	xbee_log( 1, "done:xbee_sensor_result" , (byte)ret );
	return( ret );
}

byte xbee_rx_call( XBEE_RESULT *xbee_result ){
/*
	XBeeからの受信を行うためのコールバック関数
	Ver 1.70以降はモード指定での待ち受け機能を削除した。
	mode MODE_AUTO	0x00			// 自動選択(modeに選択後のモード名が入る)
	mode MODE_UART	0x90			// UART Receive
	mode MODE_UAR2	0x91	未実装	// UART AO=0
	mode MODE_GPIN	0x92			// GPI data
	mode MODE_SENS	0x94	未実装	// XB Sensor
	mode MODE_IDNT	0x95	未実装	// Node Identify
	mode MODE_RES	0x88	異常時	// ローカルATコマンドの結果を受信
	mode MODE_RESP	0x97			// リモートATコマンドの結果を受信
	mode MODE_MODM	0x8A	異常時	// Modem Statusを受信
	mode MODE_BATT	0xE1			// (独自定義)バッテリステータス RAT%Vの応答時
	
	出力　　　：byte データ
	入力・出力：byte *mode モード値
	出力　　　：byte *xbee_result データの戻り値
	　　　　　　GPIデータ(無いGPIデータは0になるADCはFFFFになる)
	　　　　　　	 00 01 02 03 04 05 06 07 08 09 0A 0B 0C ....
	　　　　　　	|GPI  |ADC0 |ADC1 |ADC2 |ADC3 |\0|\0|\0|....
	　　　　　　UARTデータは最後が\0で戻り値がlength
*/
	byte data[API_SIZE];
	byte ret=0;
	byte return_MODE = 0x00;
	byte cache_en = 0x00;
	byte i, j;

	// 各種APIによるエラー発生の解除処理
	#ifdef ERRLOG
		if( TIMER_ERR ){
			xbee_log( 5, ERR_LOG , ERR_CODE );		// エラーログを出力
			xbee_reset();							// リセットに約3秒がかかる
			xbee_log( 3, "XBee Restarted\r\n" , 0 );
			led_red( 0 );							// エラー表示LEDをリセット
			TIMER_ERR = 0;
		}
	#endif
	
	// 応答値の初期化
	xbee_result->MODE = 0x00;	// Ver 1.70から自動受信を廃止。そのための追加
	#ifndef ARDUINO
		xbee_result->ID = 0x00;
	#endif
	for( i=0 ; i<8 ; i++ ) xbee_result->FROM[i] = 0x00;
	#ifndef ARDUINO
		for( i=0 ; i<2 ; i++ ) xbee_result->SHORT[i] = 0x00;
	#endif
	for( i=0 ; i<2 ; i++ ) xbee_result->AT[i] = 0xFF;
	xbee_result->STATUS = 0xFF;
	for( i=0 ; i<2 ; i++ ) xbee_result->GPI.BYTE[i] = 0xFF;
	for( j=0 ; i<4 ; i++ ) xbee_result->ADCIN[i] = (unsigned int)(0xFFFF);
	#ifndef ARDUINO
		for( j=0 ; i<6 ; i++ ) xbee_result->ZCL[i] = 0xFF;
	#endif
	for( i=0 ; i<CALL_SIZE ; i++ ) xbee_result->DATA[i] = 0x00;
	
	j = 0;
	#ifdef CACHE_RES
	if( CACHE_COUNTER > 0 ){
		for( i=0 ; i < API_SIZE ; i++) data[i] = CACHE_MEM[0][i];
		/* FIFO 処理 面倒なのでメモリーをコピー */
		for( j=1 ; j < CACHE_COUNTER ; j++)
			for( i=0 ; i < API_SIZE ; i++) CACHE_MEM[j-1][i] = CACHE_MEM[j][i];
		CACHE_COUNTER--;
		return_MODE = 0xFF;
		cache_en = 0xFF;		// キャッシュ有効 フラグ
		#ifdef DEBUG
			lcd_putstr("### CACHE_OUT ### -> ");	// DEBUG
			lcd_disp_hex( CACHE_COUNTER );
			lcd_putch('\n');
		#endif
	}
	#endif
	if( cache_en == 0x00 ) return_MODE = xbee_at_rx( data );	// 受信
	if( return_MODE > 0x00 ){	// キャッシュがある、または受信データがある時
		//	if(	xbee_result->MODE == 0x00 ||	// 指定(入力)されたモード値が00(オート)
		//	xbee_result->MODE == data[3] ||		// または、受信結果と一致
		//	cache_en ){							// キャッシュ動作の時
		return_MODE = xbee_from_acum( data );
		switch( return_MODE ){
			case MODE_RESP:	// 0x97 リモートATコマンドの結果を受信 Remote Command Response
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[5+i];		// アドレスはdata[5]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[13+i];// アドレスはdata[13]から
				#endif
				for( i=0 ; i<2 ; i++ ) xbee_result->AT[i] = data[15+i];	// ATはdata[15]から
				#ifndef ARDUINO
					xbee_result->ID = data[4];							// PACKET_ID
				#endif
				xbee_result->STATUS = data[17];							// statusはdata[17]
				ret = data[17];
				if( xbee_result->AT[0]=='I' && xbee_result->AT[1]=='S' ){	// ATISの受信
					ret=(data[23] & data[20]);	// GPIOの下位を受信マスクで＆して応答(要約応答)
					xbee_result->GPI.BYTE[1] = (data[22] & data[19]);	// 上位をマスクして応答
					xbee_result->GPI.BYTE[0] = ret;						// マスクが0のretも0
					for( i = 0 ; i<2 ; i++) xbee_result->DATA[i] = xbee_result->GPI.BYTE[i];
					if( data[19] == 0x00 && data[20] == 0x00 ){
						j = 1;											// デジタルデータが無いとき
					}else{
						j = 0;											// デジタルデータがある時
					}
					for( i=0; i < 4 ; i++ ){							// この中でjを使用している
						if( (data[21]>>i) & 0x01 ){						// data[21] ADCマスク
							xbee_result->ADCIN[i] =  (unsigned int)(data[(2*i+24-2*j)]);
							xbee_result->ADCIN[i] *= (unsigned int)256;
							xbee_result->ADCIN[i] += (unsigned int)(data[2*i+25-2*j]);
							xbee_result->DATA[i*2+2] = data[24+2*i-2*j];
							xbee_result->DATA[i*2+3] = data[25+2*i-2*j];
						}else{									
							xbee_result->DATA[i*2+2] = 0xFF;
							xbee_result->DATA[i*2+3] = 0xFF;
							j++;
						}
					}
				}else if( xbee_result->AT[0] == '%' && xbee_result->AT[1] == 'V'){	// BATTの受信
					return_MODE = MODE_BATT;
					xbee_result->GPI.BYTE[1] = data[18];
					xbee_result->GPI.BYTE[0] = data[19];
					xbee_result->DATA[1] = data[18];
					xbee_result->DATA[0] = data[19];
					if( xbee_result->STATUS == 0x00 ){
						xbee_result->ADCIN[0] = (unsigned int)( ( (float)data[18] * 256. + (float)data[19] ) * (1200. / 1024.) );
					}else{
						xbee_result->ADCIN[0] = 0;
					}
				}
				break;
			case MODE_GPIN:	// 0x92 GPI data を受信するモード (ZigBee IO Data Sample Ex Indicator)
				ret=xbee_gpi_acum( data );
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[4+i];		// アドレスはdata[4]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[12+i];// アドレスはdata[12]から
				#endif
				xbee_result->STATUS = data[14];							// statusはdata[14]
				xbee_result->GPI.BYTE[1] = (data[16] & data[19]);
				xbee_result->GPI.BYTE[0] = ret;
				for( i = 0 ; i<2 ; i++) xbee_result->DATA[i] = xbee_result->GPI.BYTE[i];
				if( data[16] == 0x00 && data[17] == 0x00 ){
					j = 1;												// デジタルデータが無いとき
				}else{
					j = 0;												// デジタルデータがある時
				}
				for( i=0; i < 4 ; i++ ){								// この中でjを使用している
					if( (data[18]>>i) & 0x01 ){
						xbee_result->ADCIN[i] =  (unsigned int)(data[2*i+21-2*j]);
						xbee_result->ADCIN[i] *= (unsigned int)256;
						xbee_result->ADCIN[i] += (unsigned int)(data[2*i+22-2*j]);
						xbee_result->DATA[i*2+2] = data[21+2*i-2*j];
						xbee_result->DATA[i*2+3] = data[22+2*i-2*j];
					}else {
						xbee_result->DATA[i*2+2] = 0xFF;
						xbee_result->DATA[i*2+3] = 0xFF;
						j++;
					}
					//printf("ADC[%d]=%d \n",i, (int)(xbee_result->ADC[i]) );
				}
				break;
			case MODE_UART:	// 0x90 UART data を受信するモード 戻り値はlength
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[4+i];		// アドレスはdata[4]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[12+i];// アドレスはdata[12]から
				#endif
				xbee_result->STATUS = data[14];							// statusはdata[14]
				if( ( xbee_uart_acum( data )) > 0 ){					// 以上の値は仕様書に記述誤り
					ret = data[2]-0x0C;				// 12バイト減算
					if( ret >= CALL_SIZE ) ret = CALL_SIZE -1;
					for( i=0; i<ret ; i++ ) xbee_result->DATA[i] = data[15+i];
					// xbee_result->DATA[i] = 0x00;
					xbee_result->STATUS = data[14];
				}
				break;
			case MODE_UAR2:	// 0x91 UART data 2を受信するモード
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[4+i];		// アドレスはdata[4]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[12+i];// アドレスはdata[12]から
					for(i=0;i<6;i++) xbee_result->ZCL[i] = data[14+i];	// ZCL情報data[14]から
				#endif
				xbee_result->STATUS = data[20];							// statusはdata[20]
				if( ( xbee_uart_acum( data )) > 0 ){
					ret = data[2]-0x12;				// 18バイト減算
					if( ret >= CALL_SIZE ) ret = CALL_SIZE -1;
					for( i=0; i<ret ; i++ ) xbee_result->DATA[i] = data[21+i];
					// xbee_result->DATA[i] = 0x00;
				}
				break;
			case MODE_SENS:	// 0x94 XB Sensor(1-wire)を受信するモード(未確認)
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[4+i];		// アドレスはdata[4]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[12+i];// アドレスはdata[12]から
				#endif
				xbee_result->STATUS = data[14];							// statusはdata[14]
				xbee_result->ADCIN[0] = 256*(unsigned int)data[24] + (unsigned int)data[25];
				for( i=1; i < 4 ; i++ )					// ADC値を代入、ただしAIN[0]へは代入しない
					xbee_result->ADCIN[i] = 256*(unsigned int)data[2*i+16] + (unsigned int)data[2*i+16];
				for( i=0; i<10 ; i++ ) xbee_result->DATA[i] = data[16+i];
				xbee_result->DATA[10] = data[16+i];		// sensor 01:ADC 02:Temp. 60:water present
				break;
			case MODE_IDNT:	// 0x95 Node Identifyを受信するモード(未実装,モードのみ応答)
				for(i=0;i<8;i++) xbee_result->FROM[i] = data[4+i];		// アドレスはdata[4]から
				#ifndef ARDUINO
					for(i=0;i<2;i++) xbee_result->SHORT[i] = data[12+i];	// アドレスはdata[12]から
				#endif
				xbee_result->STATUS = data[14];							// statusはdata[14]
				break;
			case MODE_RES:	// ローカルATコマンドの結果を受信(使用しない,モードのみ応答)
				for( i=0 ; i<2 ; i++ ) xbee_result->AT[i] = data[5+i];	// ATはdata[15]から
				#ifndef ARDUINO
					xbee_result->ID = data[4];								// Frame ID
				#endif
				xbee_result->STATUS = data[7];							// statusはdata[7]
				ret = data[7];
				break;
			case MODE_MODM:	// Modem Statusを受信
				xbee_result->STATUS = data[4];							// statusはdata[4]
				ret = data[4];
				break;
			default:
				xbee_log( 3, "CAUTION:recieved unknown pckt" , xbee_result->MODE );
				ret = xbee_result->MODE;
				break;
		}
		xbee_result->MODE = return_MODE;
	}
	// xbee_log( 1, "done:xbee_rx_call" , ret );
	return( ret );
}

#ifdef EASY_SENSOR
float xbee_sensor(const byte *address, const enum xbee_sensor_type type ){
/*	XBee Sensor(XBee Sensor /L/T または /L/T/H) の測定API (1-wire Sensor Adapterではない)

注意：本コマンドは応答待ちを行うので干渉によるパケット損失があります。
　　　また、センサーがスリープになっている場合はエラーになる場合が多い(タイムアウトする)
	
	これらのような場合は、xbee_forceで測定指示を出して、xbee_rx_callで受信結果を得ます。
	XBee Sensorはxbee_sensor_resultで受信結果を温度などに変換できます。

	入力：enum xbee_sensor_type {LIGHT,TEMP,HUMIDITY,WATT};	// センサタイプの型
	出力：float センサ読み取り値

設計情報
	リターン信号例
	00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
	7E 00 1B 97 01 00 13 A2 00 -- -- -- -- -- -- 49 53 00 01 08 00 0E 08 00 03 E2 02 62 02 16 A1
	  | len |mo|FI|送信元IEEEアドレス     |Short|AT(IS)  |01|GPIO |AD|GPIO |ADC1 |ADC2 |ADC3 |CS
	  |     |de|  |                       |Adrss|        |01|MASK |MS|DATA |DATA |DATA |DATA |
	  |     |  |  |                                               |  |     |Light|Temp |Humidity
	  |     |  |                          ADC MASK________________|__|
	  |     |__|__________________ MODE_RESP(0x97)= ATIS応答
	  |_____|_____________________ Data Length
*/
	XBEE_RESULT xbee_result;
	byte data[API_SIZE];
	byte j;
	float ret = -1.;

	xbee_address(address);								// 宛先のアドレスを設定
	if( xbee_tx_rx("RATIS", data , 0) > 0 ){
		if( data[3]==MODE_RESP ){						// d[3] flame ID = 97(RAT応答)
			if( data[19] == 0x00 && data[20] == 0x00 ) j = 0; else j = 2;
			xbee_result.ADC[1] = (unsigned int)data[22+j] * 256 + (unsigned int)data[23+j];
			xbee_result.ADC[2] = (unsigned int)data[24+j] * 256 + (unsigned int)data[25+j];
			xbee_result.ADC[3] = (unsigned int)data[26+j] * 256 + (unsigned int)data[27+j];
			ret = xbee_sensor_result( &xbee_result, type );
		}
	}
	xbee_log( 1, "done:xbee_sensor" , ret );
	return( ret );
}
#endif // EASY_SENSOR

void xbee_init( const byte port ){
	#ifdef LCD_H
		byte i;
	#endif
	#ifndef H3694
	#ifndef ARDUINO
		byte j,k;
	#endif
	#endif
	
	#ifndef LITE
	byte address[8];
	#endif
	
	// xbee_log( 1, "started:xbee_init" , port );
	port_init();					// 汎用入出力ポートの初期化
	timer_sec_init();				// 秒タイマー初期化
	led_green( 1 );
	
	#ifdef H3694
		sci_init( 0 );				// シリアル初期化
	#elif ARDUINO
		sci_init( 0 );				// シリアル初期化
	#else	// PC
		if( port != 0 ){
			j = sci_init( port );		// シリアル初期化
		}else{
			// ポート検索
			for( i=10 ; i>0; i--){
				j = sci_init( i );
				if( j != 0 ){
					k = xbee_reset();
					if( k > 0 ) i = 1; else j = 0;
				}
			}
		}
		if( j == 0 ){
			fprintf(stderr,"EXIT:Serial Open Error\n");
			exit(-1);
		}
	#endif
	
	#ifdef LCD_H
		#ifndef ARDUINO
			lcd_enable( 1 );				// 液晶の電源投入
			wait_millisec_250(15);			// 起動待ち
			lcd_init();						// 液晶制御ＩＣのプレ初期化
		#endif
		wait_millisec_250(15);			// 初期化待ち
		lcd_init();						// ２回目の初期化（確実な初期化）
		#ifndef ARDUINO
			lcd_control(1,0,0);				// 液晶制御 表示ON,カーソルOFF,点滅OFF
		#endif
		lcd_cls();						// 液晶消去
		lcd_goto(LCD_ROW_1);
		lcd_putstr( NAME );
		lcd_putstr(" ");
		lcd_putstr( VERSION );
		lcd_goto(LCD_ROW_2);
		lcd_putstr("by Wataru KUNINO");
	#endif
	xbee_log( 1, "xbee_reset" , 0 );
	xbee_reset();
	#ifdef LCD_H
		lcd_cls();
		lcd_goto(LCD_ROW_1);
	#endif
	#ifndef LITE
		xbee_log( 1, "xbee_init:myaddress" , port );
		if( xbee_myaddress( address ) == 0 ){			// 自分のアドレスの取得
			xbee_log( 5, "EXIT:xbee_init:myaddress" , 0 );
			#ifdef H3694
				while(1);
			#elif ARDUINO
				while(1);
			#else // PC
				exit(-1);
			#endif
		}
		#ifdef LCD_H
			for(i=0;i<4;i++){
				lcd_disp_hex(address[4+i]);
			}
			lcd_goto(LCD_ROW_1);
		#endif
	#endif
	xbee_log( 1, "done:xbee_init" , 0 );
}

void lcd_disp(const char *s){
	#ifdef LCD_H
			lcd_cls();
			lcd_goto(LCD_ROW_1);
			lcd_putstr( s );
		#ifndef H3694
			#ifndef ARDUINO
				lcd_putch( '\n' );
			#endif
		#endif
	#endif
}
